function reload()
    appsupport = "~/Library/Application Support"
    # Base directories
    @setxdg DATA_HOME appsupport
    @setxdgs DATA_DIRS ["/Library/Application Support"]
    @setxdg CONFIG_HOME appsupport
    @setxdgs CONFIG_DIRS ["/Library/Application Support"]
    @setxdg STATE_HOME appsupport
    @setxdg CACHE_HOME "~/Library/Caches"
    @setxdg RUNTIME_DIR appsupport
    @setxdg BIN_HOME let
        # There's no official convention for user-specific bin files on macos,
        # so let's check the two seemingly commonly used alternatives, then fall
        # back on the system bin folder.
        usrbin = split(get(ENV, "PATH", ""), ':') ∩ [expanduser("~/.local/bin"), "/opt/local/bin"]
        if !isempty(usrbin)
            first(usrbin)
        else
            "/usr/local/bin"
        end
    end
    # User directories
    @setxdg DESKTOP_DIR "~/Desktop"
    @setxdg DOWNLOAD_DIR "~/Downloads"
    @setxdg DOCUMENTS_DIR "~/Documents"
    @setxdg PROJECTS_DIR "~/Projects"
    @setxdg MUSIC_DIR "~/Music"
    @setxdg PICTURES_DIR "~/Pictures"
    @setxdg VIDEOS_DIR "~/Videos"
    @setxdg TEMPLATES_DIR "~/Templates"
    @setxdg PUBLICSHARE_DIR "~/Public"
    # Other directories
    global FONTS_DIRS = [
        expanduser("~/Library/Fonts"),
        "/Library/Fonts",
        "/System/Library/Fonts",
        "/System/Library/Fonts/Supplemental",
        "/Network/Library/Fonts"]
    global APPLICATIONS_DIRS = ["/Applications"]
    nothing
end

"""
    simpleascii(s::String) -> String

Convert a string to a certain 'simple' ASCII form.

This is done by replacing all non-alphanumeric characters (besides `_` and `-`)
with `-`.

While this could easily be done with a regex, unlike regex
replacement this can be precompiled, reducing TTFX.
"""
Base.@assume_effects :foldable function simpleascii(s::String)
    isvalid(b::UInt8) = UInt8('0') <= b <= UInt8('9') ||
        UInt8('A') <= b <= UInt8('Z') ||
        UInt8('a') <= b <= UInt8('z') ||
        b in (UInt8('_'), UInt8('-'))
    all(isvalid, codeunits(s)) && return s
    out = sizehint!(UInt8[], ncodeunits(s))
    for b in codeunits(s)
        if isvalid(b)
            push!(out, b)
        else
            push!(out, UInt8('-'))
        end
    end
    String(out)
end

# Copied from `unix.jl:137` for `unixapplicationpath`
Base.@assume_effects :foldable function plainascii(s::String)
    isvalid(b::UInt8) = UInt8('0') <= b <= UInt8('9') ||
        UInt8('a') <= b <= UInt8('z') ||
        b in (UInt8('_'), UInt8('-'))
    all(isvalid, codeunits(s)) && return s
    out = sizehint!(UInt8[], ncodeunits(s))
    for b in codeunits(s)
        if isvalid(b)
            push!(out, b)
        elseif UInt8('A') <= b <= UInt8('Z')
            push!(out, b ⊻ 0x20) # lowercase
        end
    end
    String(out)
end

function applicationpath(app::App, kind::Symbol, parent::String)
    startswith(parent, homedir()) || return if kind === :cache
        applicationpath(app)
    else
        applicationpath(app) * String(kind) * '/'
    end
    appsupport = joinpath(homedir(), "Library/Application Support")
    default = if kind ∈ (:data, :config, :state, :runtime)
        appsupport
    elseif kind === :cache
        joinpath(homedir(), "Library/Caches")
    else
        parent
    end
    if parent != default
        unixapplicationpath(app)
    elseif default == appsupport
        applicationpath(app) * String(kind) * '/'
    else
        applicationpath(app)
    end
end

function applicationpath(app::App, kind::Symbol, parents::Vector{String})
    if isempty(parents)
        applicationpath(app)
    else
        applicationpath(app, kind, first(parents))
    end
end

applicationpath(app::App) =
    string(join(Iterators.reverse(split(app.qualifier, '.')), '.'), '.',
           simpleascii(app.org), '.',
           simpleascii(app.name), '/')

unixapplicationpath(app::App) =
    string(plainascii(app.org), '/', plainascii(app.name), '/')

# Utilities for help in accessing/creating the relevant directories.

module User

using ..BaseDirs
using ..Internals

@static if VERSION >= v"1.11"
    eval(Expr(:public, :bin, :data, :config, :state, :cache, :runtime,
              :fonts, :applications, :desktop, :downloads, :documents,
              :music, :pictures, :videos, :templates, :public))
end

function bin(; create::Bool=false)
    path = Internals.resolvedirpath(BaseDirs.BIN_HOME, (); create)
    create && Internals.ensureexecutable(path)
    path
end
function bin(name; create::Bool=false)
    path = Internals.resolvedirpath(BaseDirs.BIN_HOME, (name,); create)
    create && Internals.ensureexecutable(path)
    path
end
function bin(project::BaseDirs.Project; create::Bool=false)
    path = Internals.resolvedirpath(BaseDirs.BIN_HOME, (project.name,); create)
    create && Internals.ensureexecutable(path)
    path
end

@defaccessor data DATA_HOME
@defaccessor config CONFIG_HOME
@defaccessor state STATE_HOME
@defaccessor cache CACHE_HOME
@defaccessor runtime RUNTIME_DIR

fonts(pathcomponents...; kwargs...) =
    Internals.resolvedirpaths(filter(p -> startswith(p, homedir()), BaseDirs.FONTS_DIRS),
                              pathcomponents; kwargs...)
applications(pathcomponents...; kwargs...) =
    Internals.resolvedirpaths(filter(p -> startswith(p, homedir()), BaseDirs.APPLICATIONS_DIRS),
                              pathcomponents; kwargs...)

desktop(pathcomponents...)   = joinpath(BaseDirs.DESKTOP_DIR,     pathcomponents...)
downloads(pathcomponents...) = joinpath(BaseDirs.DOWNLOAD_DIR,    pathcomponents...)
documents(pathcomponents...) = joinpath(BaseDirs.DOCUMENTS_DIR,   pathcomponents...)
music(pathcomponents...)     = joinpath(BaseDirs.MUSIC_DIR,       pathcomponents...)
pictures(pathcomponents...)  = joinpath(BaseDirs.PICTURES_DIR,    pathcomponents...)
videos(pathcomponents...)    = joinpath(BaseDirs.VIDEOS_DIR,      pathcomponents...)
templates(pathcomponents...) = joinpath(BaseDirs.TEMPLATES_DIR,   pathcomponents...)
public(pathcomponents...)    = joinpath(BaseDirs.PUBLICSHARE_DIR, pathcomponents...)

end

# ---------

module System

using ..BaseDirs
using ..Internals

@static if VERSION >= v"1.11"
    eval(Expr(:public, :data, :config, :fonts, :applications))
end

@defaccessor data DATA_DIRS
@defaccessor config CONFIG_DIRS

fonts(pathcomponents...; kwargs...) =
    Internals.resolvedirpaths(filter(p -> !startswith(p, homedir()), BaseDirs.FONTS_DIRS),
                              pathcomponents; kwargs...)
applications(pathcomponents...; kwargs...) =
    Internals.resolvedirpaths(filter(p -> !startswith(p, homedir()), BaseDirs.APPLICATIONS_DIRS),
                              pathcomponents; kwargs...)

end

# ---------

@defaccessor data vcat(DATA_HOME, DATA_DIRS)
@defaccessor config vcat(CONFIG_HOME, CONFIG_DIRS)
@defaccessor fonts FONTS_DIRS
@defaccessor applications APPLICATIONS_DIRS

# User accessors without system equivalents, for convenience.
const cache = User.cache
const runtime = User.runtime
const state = User.state

"""
    SYSTEMD_SERVICE

Whether the current process is a systemd service.
"""
SYSTEMD_SERVICE::Bool = false

"""
    SYSTEMD_DIRS

Sandboxed directories provided by systemd, if running as a systemd service.

These are handled according to Table 2 of [systemd.exec(5) Sandboxing](https://www.freedesktop.org/software/systemd/man/latest/systemd.exec.html#id-1.14.5.3.6.3):

| Directory                   | Below path for system units | Below path for user units  | Environment variable set  |
|:----------------------------|:----------------------------|:---------------------------|:--------------------------|
| `RuntimeDirectory=%d`       | `/run/%d`                   | `\$XDG_RUNTIME_DIR/%d`      | `RUNTIME_DIRECTORY`       |
| `StateDirectory=%d`         | `/var/lib/%d`               | `\$XDG_STATE_HOME/%d`       | `STATE_DIRECTORY`         |
| `CacheDirectory=%d`         | `/var/cache/%d`             | `\$XDG_CACHE_HOME/%d`       | `CACHE_DIRECTORY`         |
| `LogsDirectory=%d`          | `/var/log/%d`               | `\$XDG_STATE_HOME/log/%d`   | `LOGS_DIRECTORY`          |
| `ConfigurationDirectory=%d` | `/etc/%d`                   | `\$XDG_CONFIG_HOME/%d`      | `CONFIGURATION_DIRECTORY` |

Recognition of these directories is particularly important when a service is run
under a [`DynamicUser`](https://0pointer.net/blog/dynamic-users-with-systemd.html)
and trying to use the "usual" directories is liable to cause permissions errors.

It is possible for multiple directories (separated with `:`) to be set, in which case
we take the first one for consistency with the non-systemd behaviour.
"""
SYSTEMD_DIRS::@NamedTuple{runtime::String, state::String, cache::String, logs::String, config::String} =
    (runtime = "", state = "", cache = "", logs = "", config = "")

@static if VERSION < v"1.11-"
    isreadable(path) = try open(Base.isreadable, path) catch; false end
end

"""
    parseuserdirs(configdir::String) -> Dict{Symbol, String}

Parse the `user-dirs.dirs` file that lies under `configdir`.

Returns a dict with all recognised entries of the file.
"""
function parseuserdirs(configdir::String)
    validnames = ("XDG_DESKTOP_DIR", "XDG_DOWNLOAD_DIR", "XDG_TEMPLATES_DIR",
                  "XDG_PUBLICSHARE_DIR", "XDG_DOCUMENTS_DIR", "XDG_MUSIC_DIR",
                  "XDG_PICTURES_DIR", "XDG_PROJECTS_DIR", "XDG_VIDEOS_DIR")
    userdirsfile = joinpath(configdir, "user-dirs.dirs")
    entries = Dict{Symbol, String}()
    if isreadable(userdirsfile) && isfile(userdirsfile)
        for line in Iterators.map(strip, eachline(userdirsfile))
            if !startswith(line, '#') && occursin('=', line)
                key, value = split(line, '=', limit=2)
                if key in validnames
                    if startswith(value, '"') && endswith(value, '"')
                        value = try
                            unescape_string(chop(value, head=1, tail=1))
                        catch
                            continue
                        end
                    end
                    if startswith(value, "\$HOME")
                        value = string(homedir(), chopprefix(value, "\$HOME"))
                    end
                    if startswith(value, '/')
                        entries[Symbol(key)] = value
                    end
                end
            end
        end
    end
    entries
end

"""
    parsesystemuserdirs(configdir::String) -> Dict{Symbol, String}

Parse the system `user-dirs.defaults` file that lies under `configdir`.

This is the distribution-provided seed read by `xdg-user-dirs-update`. Unlike the
per-user [`parseuserdirs`](@ref) file, lines take the form `<NAME>=<path>` with a
bare key (no `XDG_` prefix or `_DIR` suffix) and an unquoted path relative to the
home directory, e.g. `DESKTOP=Desktop`.

Returns a dict keyed by the corresponding `XDG_*_DIR` symbols, with values
resolved to absolute paths, so the result merges directly with `parseuserdirs`.
"""
function parsesystemuserdirs(configdir::String)
    validnames = ("DESKTOP", "DOWNLOAD", "TEMPLATES", "PUBLICSHARE",
                  "DOCUMENTS", "MUSIC", "PICTURES", "PROJECTS", "VIDEOS")
    defaultsfile = joinpath(configdir, "user-dirs.defaults")
    entries = Dict{Symbol, String}()
    if isreadable(defaultsfile) && isfile(defaultsfile)
        for line in Iterators.map(strip, eachline(defaultsfile))
            if !startswith(line, '#') && occursin('=', line)
                key, value = split(line, '=', limit=2)
                if key in validnames && !isempty(value)
                    entries[Symbol("XDG_", key, "_DIR")] = joinpath(homedir(), value)
                end
            end
        end
    end
    entries
end

function reload()
    # Systemd detection
    @static if Sys.islinux()
        cgroup = try readchomp("/proc/self/cgroup") catch; "" end
        global SYSTEMD_SERVICE = startswith(cgroup, "0::") && endswith(cgroup, ".service")
        global SYSTEMD_DIRS = if SYSTEMD_SERVICE
            (runtime = first(eachsplit(get(ENV, "RUNTIME_DIRECTORY", ""), ':')),
             state   = first(eachsplit(get(ENV, "STATE_DIRECTORY", ""), ':')),
             cache   = first(eachsplit(get(ENV, "CACHE_DIRECTORY", ""), ':')),
             logs    = first(eachsplit(get(ENV, "LOGS_DIRECTORY", ""), ':')),
             config  = first(eachsplit(get(ENV, "CONFIGURATION_DIRECTORY", ""), ':')))
        else
            (runtime = "", state = "", cache = "", logs = "", config = "")
        end
    end
    # Base directories
    @setxdg DATA_HOME "~/.local/share"
    @setxdgs DATA_DIRS ["/usr/local/share", "/usr/share"]
    @setxdg CONFIG_HOME SYSTEMD_DIRS.config "~/.config"
    @setxdgs CONFIG_DIRS ["/etc/xdg"]
    @setxdg STATE_HOME SYSTEMD_DIRS.state "~/.local/state"
    # TODO: Introduce LOGS_HOME?
    @setxdg BIN_HOME "~/.local/bin"
    @setxdg CACHE_HOME SYSTEMD_DIRS.cache "~/.cache"
    @setxdg RUNTIME_DIR SYSTEMD_DIRS.runtime joinpath("/run/user", string(Base.Libc.getuid()))
    # User directories
    userdirs = Dict{Symbol, String}()
    for dir in Iterators.reverse(CONFIG_DIRS)
        merge!(userdirs, parsesystemuserdirs(dir))
    end
    merge!(userdirs, parseuserdirs(CONFIG_HOME))
    @setxdg DESKTOP_DIR     get(userdirs, :XDG_DESKTOP_DIR,     "~/Desktop")
    @setxdg DOWNLOAD_DIR    get(userdirs, :XDG_DOWNLOAD_DIR,    "~/Downloads")
    @setxdg DOCUMENTS_DIR   get(userdirs, :XDG_DOCUMENTS_DIR,   "~/Documents")
    @setxdg PROJECTS_DIR    get(userdirs, :XDG_PROJECTS_DIR,    "~/Projects")
    @setxdg MUSIC_DIR       get(userdirs, :XDG_MUSIC_DIR,       "~/Music")
    @setxdg PICTURES_DIR    get(userdirs, :XDG_PICTURES_DIR,    "~/Pictures")
    @setxdg VIDEOS_DIR      get(userdirs, :XDG_VIDEOS_DIR,      "~/Videos")
    @setxdg TEMPLATES_DIR   get(userdirs, :XDG_TEMPLATES_DIR,   "~/Templates")
    @setxdg PUBLICSHARE_DIR get(userdirs, :XDG_PUBLICSHARE_DIR, "~/Public")
    # Other directories
    global FONTS_DIRS =
        append!([joinpath(DATA_HOME, "fonts"), expanduser("~/.fonts")],
                [joinpath(d, "fonts") for d::String in DATA_DIRS]) |> unique
    global APPLICATIONS_DIRS =
        append!([joinpath(DATA_HOME, "applications")],
                [joinpath(d, "applications") for d::String in DATA_DIRS]) |> unique
    nothing
end

"""
    plainascii(s::String) -> String

Convert a string to a certain 'plain' ASCII form.

This is done by removing all non-alphanumeric characters (besides `_` and `-`),
and putting all letters in lower case.

While this could easily be done with a regex, unlike regex
replacement this can be precompiled, reducing TTFX.
"""
Base.@assume_effects :foldable function plainascii(s::String)
    isvalid(b::UInt8) = UInt8('0') <= b <= UInt8('9') ||
        UInt8('a') <= b <= UInt8('z') ||
        b in (UInt8('_'), UInt8('-'))
    all(isvalid, codeunits(s)) && return s
    out = sizehint!(UInt8[], ncodeunits(s))
    for b in codeunits(s)
        if isvalid(b)
            push!(out, b)
        elseif UInt8('A') <= b <= UInt8('Z')
            push!(out, b ⊻ 0x20) # lowercase
        end
    end
    String(out)
end

applicationpath(app::App, ::Symbol, parent) = applicationpath(app, parent)

function applicationpath(app::App, parent::String)
    # For quick exact matching, we can consider the pointers of
    # the strings in SYSTEMD_DIRS.
    if SYSTEMD_SERVICE && pointer(parent) ∈ map(pointer, SYSTEMD_DIRS)
        ""
    else
        applicationpath(app)
    end
end

function applicationpath(app::App, parents::Vector{String})
    if isempty(parents)
        applicationpath(app)
    else
        applicationpath(app, first(parents))
    end
end

applicationpath(app::App) =
    string(plainascii(app.org), '/', plainascii(app.name), '/')

module BaseDirs

@static if VERSION >= v"1.11"
    eval(Expr(:public, :System, :User, :App, :Project, :reload, :data, :config,
              :fonts, :applications, :cache, :runtime, :state, :DATA_HOME,
              :DATA_DIRS, :CONFIG_HOME, :CONFIG_DIRS, :BIN_HOME, :STATE_HOME,
              :CACHE_HOME, :RUNTIME_DIR, :DESKTOP_DIR, :DOWNLOAD_DIR,
              :DOCUMENTS_DIR, :MUSIC_DIR, :PICTURES_DIR, :PROJECTS_DIR,
              :VIDEOS_DIR, :TEMPLATES_DIR, :PUBLICSHARE_DIR,
              :APPLICATIONS_DIRS, :FONTS_DIRS,
              Symbol("@promise_no_assign")))
end

include("variables.jl")

function reload end
function applicationpath end

struct App
    name::String
    org::String
    qualifier::String
end

App(name::AbstractString, org::AbstractString, qualifier::AbstractString) =
    App(String(name), String(org), String(qualifier))

App(name::AbstractString; org::AbstractString="julia", qualifier::AbstractString="lang") =
    App(name, org, qualifier)

App(mod::Module) = App(String(nameof(Base.moduleroot(mod))))

function Project(args...; kwargs...)
    Base.depwarn("`Project` has been renamed to `App` as of BaseDirs v1.4", :Project)
    App(args...; kwargs...)
end

include("internals.jl")

using ..Internals

"""
    @promise_no_assign expr

Evaluate `expr`, while promising that none of the results of
`BaseDirs` will be assigned to any global constants.

This macro is intended for use in other package's precompilation scripts, to
suppress the spurious warnings about global constant assignments. It will itself
warn when used outside precompilation.

# Examples

Within a precompilation workload:

```julia
BaseDirs.@promise_no_assign MyPkg.somecall()
```

Alternatively, you could mark a larger block as safe with `begin ... end`:

```julia
BaseDirs.@promise_no_assign begin
    ...
    MyPkg.somecall()
    ...
end
```
"""
macro promise_no_assign(body)
    quote
        Internals.warn_misplaced_promise()
        Internals.PROMISED_NO_CONST_ASSIGNMENT = true
        try
            $(esc(body))
        finally
            Internals.PROMISED_NO_CONST_ASSIGNMENT = false
        end
    end
end

include("access.jl")

@static if Sys.isapple()
    const PLATFORM = :darwin
    include("darwin.jl")
elseif Sys.isunix()
    const PLATFORM = :unix
    include("unix.jl")
elseif Sys.iswindows()
    const PLATFORM = :nt
    include("nt.jl")
else
    error("Unsupported platform")
end

include("docstrings.jl")

const __init__ = reload

if ccall(:jl_generating_output, Cint, ()) != 0
    @promise_no_assign begin
        reload()
        User.bin("hey")
        for fn in (User.data, User.config, User.state, User.cache, User.runtime,
                System.data, System.config,
                data, config, fonts, applications)
            fn()
            fn("hey")
            fn("sam", "ple")
            fn(BaseDirs)
            fn(BaseDirs, "hey")
            fn(App("hey"))
            fn(App("hey"), "samp/")
        end
        for fn in (User.desktop, User.downloads, User.documents, User.music,
                User.pictures, User.videos, User.templates, User.public,
                User.fonts, User.applications, System.fonts, System.applications)
            fn()
            fn("hey")
        end
    end
end

end

# Reference: https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html

Base.Docs.doc!(@__MODULE__, # Please let me know if there's an easier way.
               Base.Docs.Binding(@__MODULE__, Symbol(@__MODULE__)),
               Base.Docs.docstr(
                   """
**BaseDirs**

This module provides utilities to identify the appropriate locations for files.

The [`User`](@ref BaseDirs.User) and [`System`](BaseDirs.System) submodules
provide a number of accessor functions, which see.

There are also four combined accessor functions defined, namely: [`data`](@ref
BaseDirs.data), [`config`](@ref BaseDirs.config), [`fonts`](@ref
BaseDirs.fonts), and [`applications`](@ref BaseDirs.applications). These provide
a list of all relevant user and system directories.

As a convenience, the three user-specific accessors [`cache`](@ref
BaseDirs.User.cache), [`runtime`](@ref BaseDirs.User.runtime), and
[`state`](@ref BaseDirs.User.state), are available under `BaseDirs` as they have
no `System` equivalent they could be confused with.

Also see [`BaseDirs.Project`](@ref BaseDirs.Project) for information on how to
generate appropriate project paths.

!!! note
    This is essentially an implementation of the XDG (Cross-Desktop Group) directory
    specifications, with analogues for Windows and MacOS for cross-platform. More
    specifically, this is a hybrid of:
    - The [*XDG base directory*](https://standards.freedesktop.org/basedir-spec/basedir-spec-latest.html)
      and the [*XDG user directory*](https://www.freedesktop.org/wiki/Software/xdg-user-dirs/) specifications on Linux
    - The [*Known Folder*](https://msdn.microsoft.com/en-us/library/windows/desktop/dd378457.aspx) API on Windows
    - The [*Standard Directories*](https://developer.apple.com/library/content/documentation/FileManagement/Conceptual/FileSystemProgrammingGuide/FileSystemOverview/FileSystemOverview.html#//apple_ref/doc/uid/TP40010672-CH2-SW6)
      guidelines on macOS

# Guidelines for appropriate directories

+ **Runtime** data is _volatile_, and only relevant to the current user session.
  It should be user-specific and non-essential. For example: sockets, named
  pipes, or lockfiles.
+ **Cache** data is non-essential and can be recreated _without data loss_. For
  example: thumbnails, compiled bytecode, font paths, or other cached data.
+ **State** data relates to application state, that should persist across _sessions_
  but doesn't need to be backed up. For example: logs, recently opened files, or
  other session data.
+ **Config** data is user-specific customisations to application behaviour. For
  example: theme settings, custom keybindings, media preferences, or other
  configuration.
+ **Data** content should be used for general application data. For example: saved
  game progress, library metadata, templates, or other
  user-specific/user-generated data.
+ **Bin** data is specifically executable files intended to be run by the user.

Essential information (that you'd want to include in backups) should be split
across **config** and **data**. Information in **state** may be nice to have,
but is non-essential.
""",
                   Dict(:path => joinpath(@__DIR__, @__FILE__),
                        :linenumber => @__LINE__,
                        :module => @__MODULE__)),
               Union{})

@doc """
     Project

A representation of a "Project", namely the essential components of naming
information used to produce platform-appropriate project paths.

    Project(name::Union{AbstractString, Module};
            org::AbstractString="julia", qualifier::AbstractString="lang")

The information needed, and the platforms that make use of it, are as follows:
- `name`, the name of the project (Linux, MacOS, Windows)
- `org` (`"julia"`), the organisation the project belongs to (MacOS, Windows)
- `qualifier` (`"org"`), the nature of the organisation, usually a TLD (MacOS)

The resulting "project path components" take one of the following forms:

| Platform | Project path form         |
|----------|---------------------------|
| Linux    | `"\$org/\$name"`            |
| MacOS    | `"\$qualifier.\$org.\$name"` |
| Windows  | `"\$org\\\$name"`           |
""" Project

# ---------

@doc """
**DATA_HOME** (`XDG_DATA_HOME`)

The single base directory relative to which user-specific data files should be
written.

**Default values**

| Linux            | MacOS                          | Windows          |
|------------------|--------------------------------|------------------|
| `~/.local/share` | `~/Library/ApplicationSupport` | `RoamingAppData` |
""" DATA_HOME

@doc """
**DATA_DIRS** (`XDG_DATA_DIRS`)

The set of *preference ordered* base directories relative to which data files
should be searched.

**Default values**

| Linux              | MacOS                         | Windows       |
|--------------------|-------------------------------|---------------|
| `/usr/local/share` | `/Library/ApplicationSupport` | `ProgramData` |
| `/usr/share`       |                               |               |
""" DATA_DIRS

@doc """
**CONFIG_HOME** (`XDG_CONFIG_HOME`)

The single base directory relative to which user-specific configuration files
should be written.

**Default values**

| Linux             | MacOS                          | Windows          |
|-------------------|--------------------------------|------------------|
| `~/.local/config` | `~/Library/ApplicationSupport` | `RoamingAppData` |
""" CONFIG_HOME

@doc """
**CONFIG_DIRS** (`XDG_CONFIG_DIRS`)

The set of *preference ordered* base directories relative to which data files
should be searched.

**Default values**

| Linux      | MacOS                         | Windows       |
|------------|-------------------------------|---------------|
| `/etc/xdg` | `/Library/ApplicationSupport` | `ProgramData` |
""" CONFIG_DIRS

@doc """
**STATE_HOME** (`XDG_STATE_HOME`)

The single base directory relative to which user-specific state data
should be written.

This should contain  state data that should persist between (application)
restarts, but that is not important or portable enough to the user that it
should be stored in `DATA_HOME`. It may contain:
- actions history (logs, history, recently used files, …)
- current state of the application that can be reused on a restart (view, layout, open files, undo history, …)

**Default values**

| Linux            | MacOS                          | Windows        |
|------------------|--------------------------------|----------------|
| `~/.local/state` | `~/Library/ApplicationSupport` | `LocalAppData` |
""" STATE_HOME

@doc """

**BIN_HOME** (`XDG_BIN_HOME`)

The single base directory relative to which user-specific executables should be
written.

**Default values**

| Linux          | MacOS\\*                         | Windows\\*             |
|----------------|--------------------------------|----------------------|
| `~/.local/bin` | `~/.local/bin`                 | `\\bin`               |
|                | `/opt/local/bin`               | `RoamingAppData\\bin` |
|                | `/usr/local/bin`               | `AppData\\bin`        |
|                |                                | current working dir  |

\\* The first of these directories that exists is used.

!!! warning
    This is not yet standardised by the XDG, see
    [freedesktop.org/xdg-specs#14](https://gitlab.freedesktop.org/xdg/xdg-specs/-/issues/14)
    for more information.
""" BIN_HOME

@doc """
**CACHE_HOME** (`XDG_CACHE_HOME`)

The single base directory relative to which user-specific non-essential (cached)
data should be written.

**Default values**

| Linux      | MacOS              | Windows              |
|------------|--------------------|----------------------|
| `~/.cache` | `~/Library/Caches` | `LocalAppData\\cache` |

""" CACHE_HOME

@doc """
**RUNTIME_DIR** (`XDG_RUNTIME_DIR`)

The single base directory relative to which user-specific runtime files and
other file objects should be placed. . Applications should use this directory
for communication and synchronization purposes and should not place larger files
in it.

**Default values**

| Linux            | MacOS                          | Windows        |
|------------------|--------------------------------|----------------|
| `/run/user/\$UID` | `~/Library/ApplicationSupport` | `LocalAppData` |
""" RUNTIME_DIR

# ---------

@doc """
**DESKTOP_DIR** (`XDG_DESKTOP_DIR`)

The user's desktop directory.
""" DESKTOP_DIR

@doc """
**DOWNLOAD_DIR** (`XDG_DOWNLOAD_DIR`)

The user's downloads directory.
""" DOWNLOAD_DIR

@doc """
**DOCUMENTS_DIR** (`XDG_DOCUMENTS_DIR`)

The user's documents directory.
""" DOCUMENTS_DIR

@doc """
**MUSIC_DIR** (`XDG_MUSIC_DIR`)

The user's music directory.
""" MUSIC_DIR

@doc """
**PICTURES_DIR** (`XDG_PICTURES_DIR`)

The user's pictures directory.
""" PICTURES_DIR

@doc """
**VIDEOS_DIR** (`XDG_VIDEOS_DIR`)

The user's videos directory.
""" VIDEOS_DIR

@doc """
**TEMPLATES_DIR** (`XDG_TEMPLATES_DIR`)

The user's templates directory.
""" TEMPLATES_DIR

@doc """
**PUBLICSHARE_DIR** (`XDG_PUBLICSHARE_DIR`)

The user's public directory.
""" PUBLICSHARE_DIR

@doc """
**APPLICATIONS_DIRS**

A list of locations in which application files may be found/placed.
""" APPLICATIONS_DIRS

@doc """
**FONTS_DIRS**

A list of locations in which font files may be found.
""" FONTS_DIRS

# ---------

@doc """
**BaseDirs.User**

This module containes accessor functions for user-specific directories.

### Base directory accessors

The functions [`data`](@ref BaseDirs.User.data), [`config`](@ref
BaseDirs.User.config), [`state`](@ref BaseDirs.User.state), [`cache`](@ref
BaseDirs.User.cache), and [`runtime`](@ref BaseDirs.User.runtime) produce a
`String`.

### User directory accessors

The functions [`desktop`](@ref BaseDirs.User.desktop), [`downloads`](@ref
BaseDirs.User.downloads), [`music`](@ref BaseDirs.User.music), [`videos`](@ref
BaseDirs.User.videos), [`templates`](@ref BaseDirs.User.templates),
[`public`](@ref BaseDirs.User.public) produce a `String`.

### Other accessors

The functions [`fonts`](@ref BaseDirs.User.fonts) and [`applications`](@ref
BaseDirs.User.applications) produce a `Vector{String}`.

!!! note
    Unlike the [`System`](@ref BaseDirs.System) and "combined" (`BaseDirs.*`)
    accessors, the *Base* and *User* accessors here return a single directory
    (`String`).
""" User

@doc """
$(Internals.accessordoc(:data, :DATA_HOME, name="user configuration"))
""" User.data

@doc """
$(Internals.accessordoc(:config, :CONFIG_HOME, name="user configuration"))
""" User.config

@doc """
$(Internals.accessordoc(:state, :STATE_HOME, name="state data"))
""" User.state

@doc """
$(Internals.accessordoc(:bin, :BIN_HOME, name="executables"))

!!! note "Special behaviour"
    When `create` is `true` and the path referrs to a file, `chmod` is called to
    ensure that all users who can read the file can execute it.
""" User.bin

@doc """
$(Internals.accessordoc(:cache, :CACHE_HOME, name="cached data"))
""" User.cache

@doc """
$(Internals.accessordoc(:state, :STATE_HOME, name="runtime information"))
""" User.runtime

@doc """
$(Internals.accessordoc(:fonts, name="user fonts", plural=true))
""" User.fonts

@doc """
$(Internals.accessordoc(:applications, name="user applications", plural=true))
""" User.applications

# ---------

@doc """
    desktop(parts...) -> String

Join the desktop directory with zero or more path components (`parts`).

The desktop directory is based on the variable `BaseDirs.DESKTOP_DIR`, which see.
""" User.desktop


@doc """
    downloads(parts...) -> String

Join the downloads directory with zero or more path components (`parts`).

The downloads directory is based on the variable `BaseDirs.DOWNLOADS_DIR`, which see.
""" User.downloads

@doc """
    documents(parts...) -> String

Join the documents directory with zero or more path components (`parts`).

The documents directory is based on the variable `BaseDirs.DOCUMENTS_DIR`, which see.
""" User.documents

@doc """
    music(parts...) -> String

Join the music directory with zero or more path components (`parts`).

The music directory is based on the variable `BaseDirs.MUSIC_DIR`, which see.
""" User.music

@doc """
    pictures(parts...) -> String

Join the pictures directory with zero or more path components (`parts`).

The pictures directory is based on the variable `BaseDirs.PICTURES_DIR`, which see.
""" User.pictures

@doc """
    videos(parts...) -> String

Join the videos directory with zero or more path components (`parts`).

The videos directory is based on the variable `BaseDirs.VIDEOS_DIR`, which see.
""" User.videos

@doc """
    templates(parts...) -> String

Join the templates directory with zero or more path components (`parts`).

The templates directory is based on the variable `BaseDirs.TEMPLATES_DIR`, which see.
""" User.templates

@doc """
    public(parts...) -> String

Join the public directory with zero or more path components (`parts`).

The public directory is based on the variable `BaseDirs.PUBLIC_DIR`, which see.
""" User.public

# ---------

@doc """
**BaseDirs.System**

This module contains accessor functions for system directories.

### Base directory accessors

The functions [`data`](@ref BaseDirs.System.data) and [`config`](@ref
BaseDirs.System.config) produce a `Vector{String}`.

### Other accessors

The functions [`fonts`](@ref BaseDirs.System.fonts) and [`applications`](@ref
BaseDirs.System.applications) produce a `Vector{String}`.

See also: [`BaseDirs.User`](@ref).
""" System

@doc """
$(Internals.accessordoc(:data, :DATA_DIRS, name="system configuration"))
""" System.data

@doc """
$(Internals.accessordoc(:config, :CONFIG_DIRS, name="system configuration"))
""" System.config

@doc """
$(Internals.accessordoc(:fonts, name="system fonts", plural=true))
""" System.fonts

@doc """
$(Internals.accessordoc(:applications, name="system applications", plural=true))
""" System.applications

# ---------

@doc """
$(Internals.accessordoc(:data, [:DATA_HOME, :DATA_DIRS], name="user and system configuration"))
""" data

@doc """
$(Internals.accessordoc(:config, [:CONFIG_HOME, :CONFIG_DIRS], name="user and system configuration"))
""" config

@doc """
$(Internals.accessordoc(:fonts, name="user and system fonts", plural=true))
""" fonts

@doc """
$(Internals.accessordoc(:applications, name="user and system applications", plural=true))
""" applications

using BaseDirs
using Test

# This test suite assumes it is running on a "default" system,
# where no customisations apply.

usr = homedir()

@testset "Project compat" begin
    @test BaseDirs.Project("foo") == BaseDirs.App("foo")
    @test BaseDirs.Project("foo", org="org") == BaseDirs.App("foo", org="org")
    @test BaseDirs.Project("foo", "org", "qual") == BaseDirs.App("foo", "org", "qual")
end

if Sys.isapple()
    @testset "Dirs" begin
        @testset "Base" begin
            @test BaseDirs.DATA_HOME == "$usr/Library/Application Support"
            @test BaseDirs.DATA_DIRS == ["/Library/Application Support"]
            @test BaseDirs.CONFIG_HOME == "$usr/Library/Application Support"
            @test BaseDirs.CONFIG_DIRS == ["/Library/Application Support"]
            if occursin("$usr/.local/bin", get(ENV, "PATH", ""))
                @test BaseDirs.BIN_HOME == "$usr/.local/bin"
            else
                @test BaseDirs.BIN_HOME == "/usr/local/bin"
            end
            @test BaseDirs.STATE_HOME == "$usr/Library/Application Support"
            @test BaseDirs.CACHE_HOME == "$usr/Library/Caches"
            @test BaseDirs.RUNTIME_DIR == "$usr/Library/Application Support"
        end
        @testset "User" begin
            @test BaseDirs.DESKTOP_DIR == "$usr/Desktop"
            @test BaseDirs.DOWNLOAD_DIR == "$usr/Downloads"
            @test BaseDirs.DOCUMENTS_DIR == "$usr/Documents"
            @test BaseDirs.PROJECTS_DIR == "$usr/Projects"
            @test BaseDirs.MUSIC_DIR == "$usr/Music"
            @test BaseDirs.PICTURES_DIR == "$usr/Pictures"
            @test BaseDirs.VIDEOS_DIR == "$usr/Videos"
            @test BaseDirs.TEMPLATES_DIR == "$usr/Templates"
            @test BaseDirs.PUBLICSHARE_DIR == "$usr/Public"
        end
        @testset "Other" begin
            @test BaseDirs.APPLICATIONS_DIRS == ["/Applications"]
            @test BaseDirs.FONTS_DIRS == ["$usr/Library/Fonts", "/Library/Fonts", "/System/Library/Fonts", "/System/Library/Fonts/Supplemental", "/Network/Library/Fonts"]
        end
    end
    @testset "User" begin
        @test BaseDirs.User.data() == "$usr/Library/Application Support"
        @test BaseDirs.User.config() == "$usr/Library/Application Support"
        @test BaseDirs.User.bin() == BaseDirs.BIN_HOME
        @test BaseDirs.User.state() == "$usr/Library/Application Support"
        @test BaseDirs.User.cache() == "$usr/Library/Caches"
        @test BaseDirs.User.runtime() == "$usr/Library/Application Support"
        @test BaseDirs.User.desktop() == "$usr/Desktop"
        @test BaseDirs.User.downloads() == "$usr/Downloads"
        @test BaseDirs.User.documents() == "$usr/Documents"
        @test BaseDirs.User.projects() == "$usr/Projects"
        @test BaseDirs.User.music() == "$usr/Music"
        @test BaseDirs.User.pictures() == "$usr/Pictures"
        @test BaseDirs.User.videos() == "$usr/Videos"
        @test BaseDirs.User.templates() == "$usr/Templates"
        @test BaseDirs.User.public() == "$usr/Public"
        @test BaseDirs.User.fonts() == ["$usr/Library/Fonts"]
        @test BaseDirs.User.applications() == String[]
    end
    @testset "System" begin
        @test BaseDirs.System.data() == ["/Library/Application Support"]
        @test BaseDirs.System.config() == ["/Library/Application Support"]
        @test BaseDirs.System.fonts() == ["/Library/Fonts", "/System/Library/Fonts", "/System/Library/Fonts/Supplemental", "/Network/Library/Fonts"]
        @test BaseDirs.System.applications() == ["/Applications"]
    end
    @testset "Other" begin
        @test BaseDirs.data() == ["$usr/Library/Application Support", "/Library/Application Support"]
        @test BaseDirs.config() == ["$usr/Library/Application Support", "/Library/Application Support"]
        @test BaseDirs.fonts() == ["$usr/Library/Fonts", "/Library/Fonts", "/System/Library/Fonts", "/System/Library/Fonts/Supplemental", "/Network/Library/Fonts"]
        @test BaseDirs.applications() == ["/Applications"]
    end
    @testset "App" begin
        @test BaseDirs.applicationpath(BaseDirs.App("a")) == "lang.julia.a/"
        @test BaseDirs.applicationpath(BaseDirs.App("Hey There")) == "lang.julia.Hey-There/"
        @test BaseDirs.applicationpath(BaseDirs.App("foo"), :state, "$usr/Library/Application Support") == "lang.julia.foo/state/"
        @test BaseDirs.applicationpath(BaseDirs.App("foo"), :state, "$usr/.local/state") == "julia/foo/"
        @test BaseDirs.applicationpath(BaseDirs.App("Hey There"), :state, "$usr/Library/Application Support") == "lang.julia.Hey-There/state/"
        @test BaseDirs.applicationpath(BaseDirs.App("Hey There"), :state, "$usr/.local/state") == "julia/heythere/"
    end
    @test isnothing(BaseDirs.reload())
elseif Sys.isunix()
    uid = rstrip(read(`id -u`, String))
    @testset "Dirs" begin
        @testset "Base" begin
            @test BaseDirs.DATA_HOME == "$usr/.local/share"
            @test BaseDirs.DATA_DIRS == ["/usr/local/share", "/usr/share"]
            @test BaseDirs.CONFIG_HOME == "$usr/.config"
            @test BaseDirs.CONFIG_DIRS == ["/etc/xdg"]
            @test BaseDirs.BIN_HOME == "$usr/.local/bin"
            @test BaseDirs.STATE_HOME == "$usr/.local/state"
            @test BaseDirs.CACHE_HOME == "$usr/.cache"
            @test BaseDirs.RUNTIME_DIR == "/run/user/$uid"
        end
        @testset "User" begin
            @test BaseDirs.DESKTOP_DIR == "$usr/Desktop"
            @test BaseDirs.DOWNLOAD_DIR == "$usr/Downloads"
            @test BaseDirs.DOCUMENTS_DIR == "$usr/Documents"
            @test BaseDirs.PROJECTS_DIR == "$usr/Projects"
            @test BaseDirs.MUSIC_DIR == "$usr/Music"
            @test BaseDirs.PICTURES_DIR == "$usr/Pictures"
            @test BaseDirs.VIDEOS_DIR == "$usr/Videos"
            @test BaseDirs.TEMPLATES_DIR == "$usr/Templates"
            @test BaseDirs.PUBLICSHARE_DIR == "$usr/Public"
        end
        @testset "Other" begin
            @test BaseDirs.APPLICATIONS_DIRS == ["$usr/.local/share/applications", "/usr/local/share/applications", "/usr/share/applications"]
            @test BaseDirs.FONTS_DIRS == ["$usr/.local/share/fonts", "$usr/.fonts", "/usr/local/share/fonts", "/usr/share/fonts"]
        end
    end
    @testset "User" begin
        @test BaseDirs.User.data() == "$usr/.local/share"
        @test BaseDirs.User.config() == "$usr/.config"
        @test BaseDirs.User.bin() == "$usr/.local/bin"
        @test BaseDirs.User.state() == "$usr/.local/state"
        @test BaseDirs.User.cache() == "$usr/.cache"
        @test BaseDirs.User.runtime() == "/run/user/$uid"
        @test BaseDirs.User.desktop() == "$usr/Desktop"
        @test BaseDirs.User.downloads() == "$usr/Downloads"
        @test BaseDirs.User.documents() == "$usr/Documents"
        @test BaseDirs.User.projects() == "$usr/Projects"
        @test BaseDirs.User.music() == "$usr/Music"
        @test BaseDirs.User.pictures() == "$usr/Pictures"
        @test BaseDirs.User.videos() == "$usr/Videos"
        @test BaseDirs.User.templates() == "$usr/Templates"
        @test BaseDirs.User.public() == "$usr/Public"
        @test BaseDirs.User.fonts() == ["$usr/.local/share/fonts", "$usr/.fonts"]
        @test BaseDirs.User.applications() == ["$usr/.local/share/applications"]
    end
    @testset "User (customised)" begin
        userdirs_jpn = raw"""
        XDG_DESKTOP_DIR="$HOME/デスクトップ"
        XDG_DOWNLOAD_DIR="$HOME/ダウンロード"
        XDG_TEMPLATES_DIR="$HOME/テンプレート"
        XDG_PUBLICSHARE_DIR="$HOME/公開"
        XDG_DOCUMENTS_DIR="$HOME/ドキュメント"
        XDG_MUSIC_DIR="$HOME/ミュージック"
        XDG_PICTURES_DIR="$HOME/ピクチャ"
        XDG_PROJECTS_DIR="$HOME/プロジェクト"
        XDG_VIDEOS_DIR="$HOME/ビデオ"
        """
        userdirs_file = joinpath(BaseDirs.CONFIG_HOME, "user-dirs.dirs")
        isfile(userdirs_file) &&
            mv(userdirs_file, userdirs_file * ".backup")
        write(userdirs_file, userdirs_jpn)
        @test BaseDirs.reload() === nothing
        @test BaseDirs.User.desktop() == "$usr/デスクトップ"
        @test BaseDirs.User.downloads() == "$usr/ダウンロード"
        @test BaseDirs.User.documents() == "$usr/ドキュメント"
        @test BaseDirs.User.projects() == "$usr/プロジェクト"
        @test BaseDirs.User.music() == "$usr/ミュージック"
        @test BaseDirs.User.pictures() == "$usr/ピクチャ"
        @test BaseDirs.User.videos() == "$usr/ビデオ"
        @test BaseDirs.User.templates() == "$usr/テンプレート"
        @test BaseDirs.User.public() == "$usr/公開"
        rm(userdirs_file)
        isfile(userdirs_file * ".backup") &&
            mv(userdirs_file * ".backup", userdirs_file)
    end
    @testset "System" begin
        @test BaseDirs.System.data() == ["/usr/local/share", "/usr/share"]
        @test BaseDirs.System.config() == ["/etc/xdg"]
        @test BaseDirs.System.fonts() == ["/usr/local/share/fonts", "/usr/share/fonts"]
        @test BaseDirs.System.applications() == ["/usr/local/share/applications", "/usr/share/applications"]
    end
    @testset "Other" begin
        @test BaseDirs.data() == ["$usr/.local/share", "/usr/local/share", "/usr/share"]
        @test BaseDirs.config() == ["$usr/.config", "/etc/xdg"]
        @test BaseDirs.fonts() == ["$usr/.local/share/fonts", "$usr/.fonts", "/usr/local/share/fonts", "/usr/share/fonts"]
        @test BaseDirs.applications() == ["$usr/.local/share/applications", "/usr/local/share/applications", "/usr/share/applications"]
    end
    @testset "App" begin
        @test BaseDirs.applicationpath(BaseDirs.App("a")) == "julia/a/"
        @test BaseDirs.applicationpath(BaseDirs.App("a"), "?") == "julia/a/"
        @test BaseDirs.applicationpath(BaseDirs.App("Hey There")) == "julia/heythere/"
    end
    @testset "Directory existence" begin
        withenv("XDG_DATA_DIRS" => "/root/forbidden:/nonexistent:/usr/share") do
            BaseDirs.reload()
            @test BaseDirs.System.data(existent = true) == ["/usr/share"]
        end
        BaseDirs.reload()
    end
    @testset "XDG_*_DIRS parsing" begin
        @testset "separator" begin
            withenv("XDG_DATA_DIRS" => "/opt/a:/opt/b") do
                BaseDirs.reload()
                @test BaseDirs.System.data() == ["/opt/a", "/opt/b"]
            end
        end
        @testset "trailing separator stripped" begin
            withenv("XDG_DATA_DIRS" => "/opt/a/:/opt/b//") do
                BaseDirs.reload()
                @test BaseDirs.System.data() == ["/opt/a", "/opt/b"]
            end
            withenv("XDG_DATA_HOME" => "/opt/home//") do
                BaseDirs.reload()
                @test BaseDirs.DATA_HOME == "/opt/home"
            end
        end
        BaseDirs.reload()
    end
    @testset "File creation" begin
        filepath = "$usr/.local/share/julia/a/my_base_dirs_julia_test_file"
        @test BaseDirs.User.data(BaseDirs.App("a"), "my_base_dirs_julia_test_file") == filepath
        rm(filepath, force=true)
        try
            @test BaseDirs.User.data(BaseDirs.App("a"), "my_base_dirs_julia_test_file", create=true) == filepath
            @test isfile(filepath)
        finally
            rm(filepath, force=true)
        end
    end
    @testset "Folder creation" begin
        folderpath = "$usr/.local/share/julia/a/my_base_dirs_julia_test_dir/"
        @test BaseDirs.User.data(BaseDirs.App("a"), "my_base_dirs_julia_test_dir/") == folderpath
        rm(folderpath, force=true)
        try
            @test BaseDirs.User.data(BaseDirs.App("a"), "my_base_dirs_julia_test_dir/", create=true) == folderpath
            @test isdir(folderpath)
        finally
            rm(folderpath, force=true)
        end
    end
    @testset "Executable creation" begin
        rm("$usr/.local/bin/my_base_dirs_julia_test_binary", force=true)
        try
            exec = BaseDirs.User.bin("my_base_dirs_julia_test_binary", create=true)
            @test exec == "$usr/.local/bin/my_base_dirs_julia_test_binary"
            @test isfile(exec)
            @test stat(exec).mode & 0o001 != 0
            @test exec == BaseDirs.User.bin("my_base_dirs_julia_test_binary", create=true)
            @test exec == BaseDirs.User.bin(BaseDirs.App("my_base_dirs_julia_test_binary"))
        finally
            rm("$usr/.local/bin/my_base_dirs_julia_test_binary", force=true)
        end
    end
    @test isnothing(BaseDirs.reload())
    @testset "User dirs" begin
        isfile("$usr/.config/user-dirs.dirs") &&
            mv("$usr/.config/user-dirs.dirs", "$usr/.config/user-dirs.dirs.backup")
        try
            write("$usr/.config/user-dirs.dirs",
                  """
                  XDG_DESKTOP_DIR="\$HOME/Workbench"
                  # A commented line
                  an invalid line
                  XDG_DOWNLOAD_DIR=/tmp/Downloads
                  XDG_TEMPLATES_DIR=/=Templates=
                  XDG_PICTURES_DIR="\$HOME/\\xZZ"
                  XDG_VIDEOS_DIR="\$HOME/Films"
                  XDG_INVALID="???"
                  """)
            @test isnothing(BaseDirs.reload())
            @test BaseDirs.User.desktop() == "$usr/Workbench"
            @test BaseDirs.User.downloads() == "/tmp/Downloads"
            @test BaseDirs.User.templates() == "/=Templates="
            @test BaseDirs.User.pictures() == "$usr/Pictures"
            @test BaseDirs.User.videos() == "$usr/Films"
        finally
            rm("$usr/.config/user-dirs.dirs", force=true)
            isfile("$usr/.config/user-dirs.dirs.backup") &&
                mv("$usr/.config/user-dirs.dirs.backup", "$usr/.config/user-dirs.dirs")
        end
    end
    @testset "System user-dirs.defaults" begin
        sysdir = mktempdir()
        write(joinpath(sysdir, "user-dirs.defaults"),
              """
              # Default settings for user directories
              DESKTOP=Desktop
              DOWNLOAD=Downloads
              MUSIC=Documents/Music
              UNKNOWN=Nope
              EMPTY=
              """)
        hadhome = isfile("$usr/.config/user-dirs.dirs")
        hadhome && mv("$usr/.config/user-dirs.dirs", "$usr/.config/user-dirs.dirs.backup")
        try
            withenv("XDG_CONFIG_DIRS" => sysdir) do
                @test isnothing(BaseDirs.reload())
                @test BaseDirs.User.desktop() == "$usr/Desktop"
                @test BaseDirs.User.downloads() == "$usr/Downloads"
                @test BaseDirs.User.music() == "$usr/Documents/Music"
                # Unrecognised/empty keys fall back to built-in defaults.
                @test BaseDirs.User.videos() == "$usr/Videos"
            end
            # A per-user entry overrides the system default.
            write("$usr/.config/user-dirs.dirs", "XDG_DESKTOP_DIR=\"\$HOME/Workbench\"\n")
            withenv("XDG_CONFIG_DIRS" => sysdir) do
                BaseDirs.reload()
                @test BaseDirs.User.desktop() == "$usr/Workbench"
                @test BaseDirs.User.downloads() == "$usr/Downloads"
            end
        finally
            rm("$usr/.config/user-dirs.dirs", force=true)
            hadhome && mv("$usr/.config/user-dirs.dirs.backup", "$usr/.config/user-dirs.dirs")
            rm(sysdir, recursive=true, force=true)
            BaseDirs.reload()
        end
    end
    @testset "Systemd Integration" begin
        has_systemd = success(`systemctl --version`)
        can_run_service = success(`systemctl --user show-environment`)
        if !has_systemd || !can_run_service
            @test_skip "Systemd integration tests require systemd and user service support"
        else
            tmpdir = mktempdir()
            test_script_plain = joinpath(tmpdir, "test_plain.jl")
            write(test_script_plain, """
            using BaseDirs

            println("SYSTEMD_SERVICE=", BaseDirs.SYSTEMD_SERVICE)
            println("User.config()=", BaseDirs.User.config())
            println("User.data()=", BaseDirs.User.data())
            println("User.state()=", BaseDirs.User.state())
            println("User.cache()=", BaseDirs.User.cache())
            println("User.runtime()=", BaseDirs.User.runtime())
            """)

            test_script_project = joinpath(tmpdir, "test_project.jl")
            write(test_script_project, """
            using BaseDirs

            proj = BaseDirs.App("testapp", org="testorg")

            println("SYSTEMD_SERVICE=", BaseDirs.SYSTEMD_SERVICE)
            println("User.config(proj)=", BaseDirs.User.config(proj))
            println("User.data(proj)=", BaseDirs.User.data(proj))
            println("User.state(proj)=", BaseDirs.User.state(proj))
            println("User.cache(proj)=", BaseDirs.User.cache(proj))
            println("User.runtime(proj)=", BaseDirs.User.runtime(proj))
            """)

            function parse_output(output::String)
                result = Dict{String, String}()
                for line in split(output, '\n')
                    if occursin('=', line)
                        key, value = split(line, '=', limit=2)
                        result[strip(key)] = strip(value)
                    end
                end
                result
            end

            julia_cmd = filter(arg -> !any(a -> startswith(arg, a), ("--color", "--depwarn", "--project", "--startup-file")), collect(Base.julia_cmd()))
            dummy_systemd_envvars = ["-E", "CONFIGURATION_DIRECTORY=C",
                                     "-E", "LOGS_DIRECTORY=L",
                                     "-E", "STATE_DIRECTORY=S",
                                     "-E", "CACHE_DIRECTORY=H",
                                     "-E", "RUNTIME_DIRECTORY=R"]

            @testset "Plain script standalone" begin
                standalone_output = read(`systemd-run --user --scope $dummy_systemd_envvars -- $julia_cmd --project=$(dirname(@__DIR__)) $test_script_plain`, String)
                standalone = parse_output(standalone_output)
                @test standalone["SYSTEMD_SERVICE"] == "false"
                @test standalone["User.config()"] == "$usr/.config"
                @test standalone["User.state()"] == "$usr/.local/state"
                @test standalone["User.cache()"] == "$usr/.cache"
                @test standalone["User.runtime()"] == "/run/user/$uid"
                @test standalone["User.data()"] == "$usr/.local/share"
            end
            @testset "Plain script as systemd service" begin
                service_name = "basedirs-test-plain-$(getpid())"
                service_file = expanduser("/etc/systemd/system/$(service_name).service")
                tmpfile = tempname()
                try
                    write(tmpfile, """
                    [Unit]
                    Description=BaseDirs Test Plain

                    [Service]
                    Type=oneshot
                    ExecStart=$(join(julia_cmd, ' ')) --project=$(dirname(@__DIR__)) $test_script_plain
                    ConfigurationDirectory=$service_name
                    StateDirectory=$service_name
                    CacheDirectory=$service_name
                    RuntimeDirectory=$service_name
                    StandardOutput=journal
                    StandardError=journal
                    """)
                    run(`sudo mkdir -p $(dirname(service_file))`)
                    run(`sudo cp $tmpfile $service_file`)
                    run(`sudo systemctl daemon-reload`)
                    run(`sudo systemctl start $(service_name).service`)
                    service_output = read(`journalctl -u $(service_name).service -n 15 --no-pager -o cat`, String)
                    service = parse_output(service_output)
                    @test service["SYSTEMD_SERVICE"] == "true"
                    @test service["User.config()"]   == "/etc/$service_name"
                    @test service["User.state()"]    == "/var/lib/$service_name"
                    @test service["User.cache()"]    == "/var/cache/$service_name"
                    @test service["User.runtime()"]  == "/run/$service_name"
                finally
                    run(`sudo systemctl stop $(service_name).service`)
                    run(`sudo rm $service_file`)
                    run(`sudo systemctl daemon-reload`)
                end
            end
            @testset "Project script standalone" begin
                standalone_output = read(`systemd-run --user --scope $dummy_systemd_envvars -- $julia_cmd --startup-file=no --project=$(dirname(@__DIR__)) $test_script_project`, String)
                standalone = parse_output(standalone_output)
                @test standalone["SYSTEMD_SERVICE"] == "false"
                @test occursin("testorg", standalone["User.config(proj)"])
            end
            @testset "Project script as systemd service" begin
                service_name = "basedirs-test-project-$(getpid())"
                service_file = expanduser("/etc/systemd/system/$(service_name).service")
                tmpfile = tempname()
                try
                    write(tmpfile, """
                    [Unit]
                    Description=BaseDirs Test Project

                    [Service]
                    Type=oneshot
                    ExecStart=$(join(julia_cmd, ' ')) --startup-file=no --project=$(dirname(@__DIR__)) $test_script_project
                    ConfigurationDirectory=$service_name
                    StateDirectory=$service_name
                    CacheDirectory=$service_name
                    RuntimeDirectory=$service_name
                    StandardOutput=journal
                    StandardError=journal
                    """)
                    run(`sudo cp $tmpfile $service_file`)
                    run(`sudo systemctl daemon-reload`)
                    run(`sudo systemctl start $(service_name).service`)
                    # Get service output from journal
                    service_output = read(`journalctl -u $(service_name).service -n 15 --no-pager -o cat`, String)
                    service = parse_output(service_output)
                    # Verify systemd detection
                    @test service["SYSTEMD_SERVICE"] == "true"
                    @test !occursin("testorg", service["User.config(proj)"])
                    @test chopsuffix(service["User.config(proj)"],  "/") == "/etc/$service_name"
                    @test chopsuffix(service["User.state(proj)"],   "/") == "/var/lib/$service_name"
                    @test chopsuffix(service["User.cache(proj)"],   "/") == "/var/cache/$service_name"
                    @test chopsuffix(service["User.runtime(proj)"], "/") == "/run/$service_name"
                finally
                    run(`sudo systemctl stop $(service_name).service`)
                    run(`sudo rm $service_file`)
                    run(`sudo systemctl daemon-reload`)
                end
            end
        end
    end
elseif Sys.iswindows()
    @testset "OS specific" begin
        fieldvals(x::T) where {T} = ntuple(fieldcount(T)) do i
            getfield(x, i)
        end
        @test fieldvals(BaseDirs.relevantfolders()) == fieldvals(BaseDirs.RelevantFolders(
            "C:", "C:\\Windows", "C:\\ProgramData",
            "$usr\\AppData\\Roaming\\Microsoft\\Windows\\Start Menu\\Programs",
            "C:\\ProgramData\\Microsoft\\Windows\\Start Menu\\Programs",
            "$usr", "$usr\\AppData\\Roaming", "$usr\\AppData\\Local",
            "$usr\\Desktop", "$usr\\Downloads", "$usr\\Documents",
            "$usr\\Music", "$usr\\Pictures", "$usr\\Videos",
            "$usr\\AppData\\Roaming\\Microsoft\\Windows\\Templates",
            "C:\\Users\\Public", "C:\\Windows\\Fonts"))
    end
    @testset "Dirs" begin
        @testset "Base" begin
            @test BaseDirs.DATA_HOME == "$usr\\AppData\\Roaming"
            @test BaseDirs.DATA_DIRS == ["C:\\ProgramData"]
            @test BaseDirs.CONFIG_HOME == "$usr\\AppData\\Roaming"
            @test BaseDirs.CONFIG_DIRS == ["C:\\ProgramData"]
            @test BaseDirs.BIN_HOME == "$usr\\bin"
            @test BaseDirs.STATE_HOME == "$usr\\AppData\\Local"
            @test BaseDirs.CACHE_HOME == "$usr\\AppData\\Local\\cache"
            @test BaseDirs.RUNTIME_DIR == "$usr\\AppData\\Local"
        end
        @testset "User" begin
            @test BaseDirs.DESKTOP_DIR == "$usr\\Desktop"
            @test BaseDirs.DOWNLOAD_DIR == "$usr\\Downloads"
            @test BaseDirs.DOCUMENTS_DIR == "$usr\\Documents"
            @test BaseDirs.PROJECTS_DIR == "$usr\\Projects"
            @test BaseDirs.MUSIC_DIR == "$usr\\Music"
            @test BaseDirs.PICTURES_DIR == "$usr\\Pictures"
            @test BaseDirs.VIDEOS_DIR == "$usr\\Videos"
            @test BaseDirs.TEMPLATES_DIR == "$usr\\AppData\\Roaming\\Microsoft\\Windows\\Templates"
            @test BaseDirs.PUBLICSHARE_DIR == "C:\\Users\\Public"
        end
        @testset "Other" begin
            @test BaseDirs.APPLICATIONS_DIRS == ["$usr\\AppData\\Roaming\\Microsoft\\Windows\\Start Menu\\Programs", "C:\\ProgramData\\Microsoft\\Windows\\Start Menu\\Programs"]
            @test BaseDirs.FONTS_DIRS == ["C:\\Windows\\Fonts", "$usr\\AppData\\Local\\Microsoft\\Windows\\Fonts"]
        end
    end
    @testset "User" begin
        @test BaseDirs.User.data() == "$usr\\AppData\\Roaming"
        @test BaseDirs.User.config() == "$usr\\AppData\\Roaming"
        @test BaseDirs.User.bin() == "$usr\\bin"
        @test BaseDirs.User.state() == "$usr\\AppData\\Local"
        @test BaseDirs.User.cache() == "$usr\\AppData\\Local\\cache"
        @test BaseDirs.User.runtime() == "$usr\\AppData\\Local"
        @test BaseDirs.User.desktop() == "$usr\\Desktop"
        @test BaseDirs.User.downloads() == "$usr\\Downloads"
        @test BaseDirs.User.documents() == "$usr\\Documents"
        @test BaseDirs.User.projects() == "$usr\\Projects"
        @test BaseDirs.User.music() == "$usr\\Music"
        @test BaseDirs.User.pictures() == "$usr\\Pictures"
        @test BaseDirs.User.videos() == "$usr\\Videos"
        @test BaseDirs.User.templates() == "$usr\\AppData\\Roaming\\Microsoft\\Windows\\Templates"
        @test BaseDirs.User.public() == "C:\\Users\\Public"
        @test BaseDirs.User.fonts() == ["$usr\\AppData\\Local\\Microsoft\\Windows\\Fonts"]
        @test BaseDirs.User.applications() == ["$usr\\AppData\\Roaming\\Microsoft\\Windows\\Start Menu\\Programs"]
    end
    @testset "System" begin
        @test BaseDirs.System.data() == ["C:\\ProgramData"]
        @test BaseDirs.System.config() == ["C:\\ProgramData"]
        @test BaseDirs.System.fonts() == ["C:\\Windows\\Fonts"]
        @test BaseDirs.System.applications() == ["C:\\ProgramData\\Microsoft\\Windows\\Start Menu\\Programs"]
    end
    @testset "Others" begin
        @test BaseDirs.data() == ["$usr\\AppData\\Roaming", "C:\\ProgramData"]
        @test BaseDirs.config() == ["$usr\\AppData\\Roaming", "C:\\ProgramData"]
        @test BaseDirs.fonts() == ["C:\\Windows\\Fonts", "$usr\\AppData\\Local\\Microsoft\\Windows\\Fonts"]
        @test BaseDirs.applications() == ["$usr\\AppData\\Roaming\\Microsoft\\Windows\\Start Menu\\Programs", "C:\\ProgramData\\Microsoft\\Windows\\Start Menu\\Programs"]
    end
    @testset "Projects" begin
        @test BaseDirs.applicationpath(BaseDirs.App("a")) == "julia\\a\\"
        @test BaseDirs.applicationpath(BaseDirs.App("a", org="b")) == "b\\a\\"
        @test BaseDirs.applicationpath(BaseDirs.App("a"), :data, BaseDirs.DATA_HOME) == "julia\\a\\data\\"
        if BaseDirs.CONFIG_HOME != BaseDirs.DATA_HOME
            @test BaseDirs.applicationpath(BaseDirs.App("a"), :config, BaseDirs.CONFIG_HOME) == "julia\\a\\config\\"
        end
        @test BaseDirs.applicationpath(BaseDirs.App("a"), :cache, BaseDirs.CACHE_HOME) == "julia\\a\\cache\\"
        @test BaseDirs.applicationpath(BaseDirs.App("a"), :state, BaseDirs.STATE_HOME) == "julia\\a\\state\\"
    end
    @testset "XDG_*_DIRS parsing" begin
        @testset "separator" begin
            withenv("XDG_DATA_DIRS" => "C:\\A;D:\\B") do
                BaseDirs.reload()
                @test BaseDirs.System.data() == ["C:\\A", "D:\\B"]
            end
        end
        @testset "trailing separator stripped" begin
            withenv("XDG_DATA_DIRS" => "C:\\A\\;D:\\B/") do
                BaseDirs.reload()
                @test BaseDirs.System.data() == ["C:\\A", "D:\\B"]
            end
            withenv("XDG_DATA_HOME" => "C:\\Home\\/") do
                BaseDirs.reload()
                @test BaseDirs.DATA_HOME == "C:\\Home"
            end
        end
    end
    @test isnothing(BaseDirs.reload())
end

@static if VERSION < v"1.12"
    @test_skip "Precompilation warning tests require Julia 1.12 or later, and misbehave on Windows"
else
    @testset "Precompilation warnings" begin
        @test_warn "is likely misplaced" BaseDirs.@promise_no_assign 1+1
        function precompile_output(proj::String)
            out = IOBuffer()
            err = IOBuffer()
            for dep in DEPOT_PATH
                projdir = joinpath(dep, "compiled", string('v', VERSION.major, '.', VERSION.minor), basename(proj))
                isdir(projdir) && rm(projdir; force=true, recursive=true)
            end
            julia_cmd = filter(arg -> !any(a -> startswith(arg, a), ("--code-coverage", "--color", "--depwarn", "--project", "--startup-file")), collect(Base.julia_cmd()))
            precompile_cmd = addenv(`$julia_cmd --startup-file=no --color=no --project=$proj -e "using Pkg; Pkg.precompile()"`,
                                    "JULIA_LOAD_PATH" => ifelse(Sys.iswindows(), ";", ":"))
            try
                run(pipeline(precompile_cmd, stdout=out, stderr=err))
            catch
                error("Precompilation failed!\nCMD:\n$precompile_cmd\n\nSTDOUT:\n$(String(take!(out)))\nSTDERR:\n$(String(take!(err)))")
            end
            (stdout = String(take!(out)), stderr = String(take!(err)))
        end
        precompile_badassign = precompile_output(joinpath(@__DIR__, "BaseDirs_TestBadAssign"))
        @test contains(precompile_badassign.stderr, "Warning: A base directory is being computed during precompilation.")
        precompile_promiseassign = precompile_output(joinpath(@__DIR__, "BaseDirs_TestPromiseAssign"))
        @test !contains(precompile_promiseassign.stderr, "Warning:")
    end
end

# This implementation took a toll on my sanity over the many /hours/ it took to
# get right, as opposed to the handful of minutes darwin.jl and unix.jl took.

struct StupidWindowsGUID
    d1::UInt32
    d2::UInt16
    d3::UInt16
    d4::NTuple{8, UInt8}
end

const KNOWN_FOLDER_IDS = Dict{Symbol, StupidWindowsGUID}(
    :AccountPictures        => StupidWindowsGUID(0x008ca0b1, 0x55b4, 0x4c56, (0xb8, 0xa8, 0x4d, 0xe4, 0xb2, 0x99, 0xd3, 0xbe)),
    :AddNewPrograms         => StupidWindowsGUID(0xde61d971, 0x5ebc, 0x4f02, (0xa3, 0xa9, 0x6c, 0x82, 0x89, 0x5e, 0x5c, 0x04)),
    :AdminTools             => StupidWindowsGUID(0x724ef170, 0xa42d, 0x4fef, (0x9f, 0x26, 0xb6, 0x0e, 0x84, 0x6f, 0xba, 0x4f)),
    :AllAppMods             => StupidWindowsGUID(0x7ad67899, 0x66af, 0x43ba, (0x91, 0x56, 0x6a, 0xad, 0x42, 0xe6, 0xc5, 0x96)),
    :AppCaptures            => StupidWindowsGUID(0xedc0fe71, 0x98d8, 0x4f4a, (0xb9, 0x20, 0xc8, 0xdc, 0x13, 0x3c, 0xb1, 0x65)),
    :AppDataDesktop         => StupidWindowsGUID(0xb2c5e279, 0x7add, 0x439f, (0xb2, 0x8c, 0xc4, 0x1f, 0xe1, 0xbb, 0xf6, 0x72)),
    :AppDataDocuments       => StupidWindowsGUID(0x7be16610, 0x1f7f, 0x44ac, (0xbf, 0xf0, 0x83, 0xe1, 0x5f, 0x2f, 0xfc, 0xa1)),
    :AppDataFavorites       => StupidWindowsGUID(0x7cfbefbc, 0xde1f, 0x45aa, (0xb8, 0x43, 0xa5, 0x42, 0xac, 0x53, 0x6c, 0xc9)),
    :AppDataProgramData     => StupidWindowsGUID(0x559d40a3, 0xa036, 0x40fa, (0xaf, 0x61, 0x84, 0xcb, 0x43, 0x0a, 0x4d, 0x34)),
    :ApplicationShortcuts   => StupidWindowsGUID(0xa3918781, 0xe5f2, 0x4890, (0xb3, 0xd9, 0xa7, 0xe5, 0x43, 0x32, 0x32, 0x8c)),
    :AppsFolder             => StupidWindowsGUID(0x1e87508d, 0x89c2, 0x42f0, (0x8a, 0x7e, 0x64, 0x5a, 0x0f, 0x50, 0xca, 0x58)),
    :AppUpdates             => StupidWindowsGUID(0xa305ce99, 0xf527, 0x492b, (0x8b, 0x1a, 0x7e, 0x76, 0xfa, 0x98, 0xd6, 0xe4)),
    :CameraRoll             => StupidWindowsGUID(0xab5fb87b, 0x7ce2, 0x4f83, (0x91, 0x5d, 0x55, 0x08, 0x46, 0xc9, 0x53, 0x7b)),
    :CameraRollLibrary      => StupidWindowsGUID(0x2b20df75, 0x1eda, 0x4039, (0x80, 0x97, 0x38, 0x79, 0x82, 0x27, 0xd5, 0xb7)),
    :CDBurning              => StupidWindowsGUID(0x9e52ab10, 0xf80d, 0x49df, (0xac, 0xb8, 0x43, 0x30, 0xf5, 0x68, 0x78, 0x55)),
    :ChangeRemovePrograms   => StupidWindowsGUID(0xdf7266ac, 0x9274, 0x4867, (0x8d, 0x55, 0x3b, 0xd6, 0x61, 0xde, 0x87, 0x2d)),
    :CommonAdminTools       => StupidWindowsGUID(0xd0384e7d, 0xbac3, 0x4797, (0x8f, 0x14, 0xcb, 0xa2, 0x29, 0xb3, 0x92, 0xb5)),
    :CommonOEMLinks         => StupidWindowsGUID(0xc1bae2d0, 0x10df, 0x4334, (0xbe, 0xdd, 0x7a, 0xa2, 0x0b, 0x22, 0x7a, 0x9d)),
    :CommonPrograms         => StupidWindowsGUID(0x0139d44e, 0x6afe, 0x49f2, (0x86, 0x90, 0x3d, 0xaf, 0xca, 0xe6, 0xff, 0xb8)),
    :CommonStartMenu        => StupidWindowsGUID(0xa4115719, 0xd62e, 0x491d, (0xaa, 0x7c, 0xe7, 0x4b, 0x8b, 0xe3, 0xb0, 0x67)),
    :CommonStartMenuPlaces  => StupidWindowsGUID(0xa440879f, 0x87a0, 0x4f7d, (0xb7, 0x00, 0x02, 0x07, 0xb9, 0x66, 0x19, 0x4A)),
    :CommonStartup          => StupidWindowsGUID(0x82A5Ea35, 0xd9cd, 0x47c5, (0x96, 0x29, 0xe1, 0x5d, 0x2f, 0x71, 0x4e, 0x6e)),
    :commonTemplates        => StupidWindowsGUID(0xB94237E7, 0x57AC, 0x4347, (0x91, 0x51, 0xB0, 0x8C, 0x6C, 0x32, 0xD1, 0xF7)),
    :ComputerFolder         => StupidWindowsGUID(0x0ac0837c, 0xbbf8, 0x452a, (0x85, 0x0d, 0x79, 0xd0, 0x8e, 0x66, 0x7c, 0xa7)),
    :ConflictFolder         => StupidWindowsGUID(0x4bfefb45, 0x347d, 0x4006, (0xa5, 0xbe, 0xac, 0x0c, 0xb0, 0x56, 0x71, 0x92)),
    :ConnectionsFolder      => StupidWindowsGUID(0x6f0cd92b, 0x2e97, 0x45d1, (0x88, 0xff, 0xb0, 0xd1, 0x86, 0xb8, 0xde, 0xdd)),
    :Contacts               => StupidWindowsGUID(0x56784854, 0xc6cb, 0x462b, (0x81, 0x69, 0x88, 0xe3, 0x50, 0xac, 0xb8, 0x82)),
    :ControlPanelFolder     => StupidWindowsGUID(0x82a74aeb, 0xaeb4, 0x465c, (0xa0, 0x14, 0xd0, 0x97, 0xee, 0x34, 0x6d, 0x63)),
    :Cookies                => StupidWindowsGUID(0x2b0f765d, 0xc0e9, 0x4171, (0x90, 0x8e, 0x08, 0xa6, 0x11, 0xb8, 0x4f, 0xf6)),
    :CurrentAppMods         => StupidWindowsGUID(0x3db40b20, 0x2a30, 0x4dbe, (0x91, 0x7e, 0x77, 0x1d, 0xd2, 0x1d, 0xd0, 0x99)),
    :Desktop                => StupidWindowsGUID(0xb4bfcc3a, 0xdb2c, 0x424c, (0xb0, 0x29, 0x7f, 0xe9, 0x9a, 0x87, 0xc6, 0x41)),
    :DevelopmentFiles       => StupidWindowsGUID(0xdbe8e08e, 0x3053, 0x4bbc, (0xb1, 0x83, 0x2a, 0x7b, 0x2b, 0x19, 0x1e, 0x59)),
    :Device                 => StupidWindowsGUID(0x1c2ac1dc, 0x4358, 0x4b6c, (0x97, 0x33, 0xaf, 0x21, 0x15, 0x65, 0x76, 0xf0)),
    :DeviceMetadataStore    => StupidWindowsGUID(0x5ce4a5e9, 0xe4eb, 0x479d, (0xb8, 0x9f, 0x13, 0x0c, 0x02, 0x88, 0x61, 0x55)),
    :Documents              => StupidWindowsGUID(0xfdd39ad0, 0x238f, 0x46af, (0xad, 0xb4, 0x6c, 0x85, 0x48, 0x03, 0x69, 0xc7)),
    :DocumentsLibrary       => StupidWindowsGUID(0x7b0db17d, 0x9cd2, 0x4a93, (0x97, 0x33, 0x46, 0xcc, 0x89, 0x02, 0x2e, 0x7c)),
    :Downloads              => StupidWindowsGUID(0x374de290, 0x123f, 0x4565, (0x91, 0x64, 0x39, 0xc4, 0x92, 0x5e, 0x46, 0x7b)),
    :Favorites              => StupidWindowsGUID(0x1777f761, 0x68ad, 0x4d8a, (0x87, 0xbd, 0x30, 0xb7, 0x59, 0xfa, 0x33, 0xdd)),
    :Fonts                  => StupidWindowsGUID(0xfd228cb7, 0xae11, 0x4ae3, (0x86, 0x4c, 0x16, 0xf3, 0x91, 0x0a, 0xb8, 0xfe)),
    :Games                  => StupidWindowsGUID(0xcac52c1a, 0xb53d, 0x4edc, (0x92, 0xd7, 0x6b, 0x2e, 0x8a, 0xc1, 0x94, 0x34)),
    :GameTasks              => StupidWindowsGUID(0x054fae61, 0x4dd8, 0x4787, (0x80, 0xb6, 0x09, 0x02, 0x20, 0xc4, 0xb7, 0x00)),
    :History                => StupidWindowsGUID(0xd9dc8a3b, 0xb784, 0x432e, (0xa7, 0x81, 0x5a, 0x11, 0x30, 0xa7, 0x59, 0x63)),
    :HomeGroup              => StupidWindowsGUID(0x52528a6b, 0xb9e3, 0x4add, (0xb6, 0x0d, 0x58, 0x8c, 0x2d, 0xba, 0x84, 0x2d)),
    :HomeGroupCurrentUser   => StupidWindowsGUID(0x9b74b6a3, 0x0dfd, 0x4f11, (0x9e, 0x78, 0x5f, 0x78, 0x00, 0xf2, 0xe7, 0x72)),
    :ImplicitAppShortcuts   => StupidWindowsGUID(0xbcb5256f, 0x79f6, 0x4cee, (0xb7, 0x25, 0xdc, 0x34, 0xe4, 0x02, 0xfd, 0x46)),
    :InternetCache          => StupidWindowsGUID(0x352481e8, 0x33be, 0x4251, (0xba, 0x85, 0x60, 0x07, 0xca, 0xed, 0xcf, 0x9d)),
    :InternetFolder         => StupidWindowsGUID(0x4d9f7874, 0x4e0c, 0x4904, (0x96, 0x7b, 0x40, 0xb0, 0xd2, 0x0c, 0x3e, 0x4b)),
    :Libraries              => StupidWindowsGUID(0x1b3ea5dc, 0xb587, 0x4786, (0xb4, 0xef, 0xbd, 0x1d, 0xc3, 0x32, 0xae, 0xae)),
    :Links                  => StupidWindowsGUID(0xbfb9d5e0, 0xc6a9, 0x404c, (0xb2, 0xb2, 0xae, 0x6d, 0xb6, 0xaf, 0x49, 0x68)),
    :LocalAppData           => StupidWindowsGUID(0xf1b32785, 0x6fba, 0x4fcf, (0x9d, 0x55, 0x7b, 0x8e, 0x7f, 0x15, 0x70, 0x91)),
    :LocalAppDataLow        => StupidWindowsGUID(0xa520a1a4, 0x1780, 0x4ff6, (0xbd, 0x18, 0x16, 0x73, 0x43, 0xc5, 0xaf, 0x16)),
    :LocalDocuments         => StupidWindowsGUID(0xf42ee2d3, 0x909f, 0x4907, (0x88, 0x71, 0x4c, 0x22, 0xfc, 0x0b, 0xf7, 0x56)),
    :LocalDownloads         => StupidWindowsGUID(0x7d83ee9b, 0x2244, 0x4e70, (0xb1, 0xf5, 0x53, 0x93, 0x04, 0x2a, 0xf1, 0xe4)),
    :LocalizedResourcesDir  => StupidWindowsGUID(0x2a00375e, 0x224c, 0x49de, (0xb8, 0xd1, 0x44, 0x0d, 0xf7, 0xef, 0x3d, 0xdc)),
    :LocalMusic             => StupidWindowsGUID(0xa0c69a99, 0x21c8, 0x4671, (0x87, 0x03, 0x79, 0x34, 0x16, 0x2f, 0xcf, 0x1d)),
    :LocalPictures          => StupidWindowsGUID(0x0ddd015d, 0xb06c, 0x45d5, (0x8c, 0x4c, 0xf5, 0x97, 0x13, 0x85, 0x46, 0x39)),
    :LocalVideos            => StupidWindowsGUID(0x35286a68, 0x3c57, 0x41a1, (0xbb, 0xb1, 0x0e, 0xae, 0x73, 0xd7, 0x6c, 0x95)),
    :Music                  => StupidWindowsGUID(0x4bd8d571, 0x6d19, 0x48d3, (0xbe, 0x97, 0x42, 0x22, 0x20, 0x08, 0x0e, 0x43)),
    :MusicLibrary           => StupidWindowsGUID(0x2112ab0a, 0xc86a, 0x4ffe, (0xa3, 0x68, 0x0d, 0xe9, 0x6e, 0x47, 0x01, 0x2e)),
    :NetHood                => StupidWindowsGUID(0xc5abbf53, 0xe17f, 0x4121, (0x89, 0x00, 0x86, 0x62, 0x6f, 0xc2, 0xc9, 0x73)),
    :NetworkFolder          => StupidWindowsGUID(0xd20beec4, 0x5ca8, 0x4905, (0xae, 0x3b, 0xbf, 0x25, 0x1e, 0xa0, 0x9b, 0x53)),
    :Objects3D              => StupidWindowsGUID(0x31c0dd25, 0x9439, 0x4f12, (0xbf, 0x41, 0x7f, 0xf4, 0xed, 0xa3, 0x87, 0x22)),
    :OneDrive               => StupidWindowsGUID(0xa52bba46, 0xe9e1, 0x435f, (0xb3, 0xd9, 0x28, 0xda, 0xa6, 0x48, 0xc0, 0xf6)),
    :OriginalImages         => StupidWindowsGUID(0x2c36c0aa, 0x5812, 0x4b87, (0xbf, 0xd0, 0x4c, 0xd0, 0xdf, 0xb1, 0x9b, 0x39)),
    :PhotoAlbums            => StupidWindowsGUID(0x69d2cf90, 0xfc33, 0x4fb7, (0x9a, 0x0c, 0xeb, 0xb0, 0xf0, 0xfc, 0xb4, 0x3c)),
    :Pictures               => StupidWindowsGUID(0x33e28130, 0x4e1e, 0x4676, (0x83, 0x5a, 0x98, 0x39, 0x5c, 0x3b, 0xc3, 0xbb)),
    :PicturesLibrary        => StupidWindowsGUID(0xa990ae9f, 0xa03b, 0x4e80, (0x94, 0xbc, 0x99, 0x12, 0xd7, 0x50, 0x41, 0x04)),
    :Playlists              => StupidWindowsGUID(0xde92c1c7, 0x837f, 0x4f69, (0xa3, 0xbb, 0x86, 0xe6, 0x31, 0x20, 0x4a, 0x23)),
    :PrintersFolder         => StupidWindowsGUID(0x76fc4e2d, 0xd6ad, 0x4519, (0xa6, 0x63, 0x37, 0xbd, 0x56, 0x06, 0x81, 0x85)),
    :PrintHood              => StupidWindowsGUID(0x9274bd8d, 0xcfd1, 0x41c3, (0xb3, 0x5e, 0xb1, 0x3f, 0x55, 0xa7, 0x58, 0xf4)),
    :Profile                => StupidWindowsGUID(0x5e6c858f, 0x0e22, 0x4760, (0x9a, 0xfe, 0xea, 0x33, 0x17, 0xb6, 0x71, 0x73)),
    :ProgramData            => StupidWindowsGUID(0x62ab5d82, 0xfdc1, 0x4dc3, (0xa9, 0xdd, 0x07, 0x0d, 0x1d, 0x49, 0x5d, 0x97)),
    :ProgramFiles           => StupidWindowsGUID(0x905e63b6, 0xc1bf, 0x494e, (0xb2, 0x9c, 0x65, 0xb7, 0x32, 0xd3, 0xd2, 0x1a)),
    :ProgramFilesCommon     => StupidWindowsGUID(0xf7f1ed05, 0x9f6d, 0x47a2, (0xaa, 0xae, 0x29, 0xd3, 0x17, 0xc6, 0xf0, 0x66)),
    :ProgramFilesCommonX64  => StupidWindowsGUID(0x6365d5a7, 0x0f0d, 0x45e5, (0x87, 0xf6, 0x0d, 0xa5, 0x6b, 0x6a, 0x4f, 0x7d)),
    :ProgramFilesCommonX86  => StupidWindowsGUID(0xde974d24, 0xd9c6, 0x4d3e, (0xbf, 0x91, 0xf4, 0x45, 0x51, 0x20, 0xb9, 0x17)),
    :ProgramFilesX64        => StupidWindowsGUID(0x6d809377, 0x6af0, 0x444b, (0x89, 0x57, 0xa3, 0x77, 0x3f, 0x02, 0x20, 0x0e)),
    :ProgramFilesX86        => StupidWindowsGUID(0x7c5a40ef, 0xa0fb, 0x4bfc, (0x87, 0x4a, 0xc0, 0xf2, 0xe0, 0xb9, 0xfa, 0x8e)),
    :Programs               => StupidWindowsGUID(0xa77f5d77, 0x2e2b, 0x44c3, (0xa6, 0xa2, 0xab, 0xa6, 0x01, 0x05, 0x4a, 0x51)),
    :Public                 => StupidWindowsGUID(0xdfdf76a2, 0xc82a, 0x4d63, (0x90, 0x6a, 0x56, 0x44, 0xac, 0x45, 0x73, 0x85)),
    :PublicDesktop          => StupidWindowsGUID(0xc4aa340d, 0xf20f, 0x4863, (0xaf, 0xef, 0xf8, 0x7e, 0xf2, 0xe6, 0xba, 0x25)),
    :PublicDocuments        => StupidWindowsGUID(0xed4824af, 0xdce4, 0x45a8, (0x81, 0xe2, 0xfc, 0x79, 0x65, 0x08, 0x36, 0x34)),
    :PublicDownloads        => StupidWindowsGUID(0x3d644c9b, 0x1fb8, 0x4f30, (0x9b, 0x45, 0xf6, 0x70, 0x23, 0x5f, 0x79, 0xc0)),
    :PublicGameTasks        => StupidWindowsGUID(0xdebf2536, 0xe1a8, 0x4c59, (0xb6, 0xa2, 0x41, 0x45, 0x86, 0x47, 0x6a, 0xea)),
    :PublicLibraries        => StupidWindowsGUID(0x48daf80b, 0xe6cf, 0x4f4e, (0xb8, 0x00, 0x0e, 0x69, 0xd8, 0x4e, 0xe3, 0x84)),
    :PublicMusic            => StupidWindowsGUID(0x3214fab5, 0x9757, 0x4298, (0xbb, 0x61, 0x92, 0xa9, 0xde, 0xaa, 0x44, 0xff)),
    :PublicPictures         => StupidWindowsGUID(0xb6ebfb86, 0x6907, 0x413c, (0x9a, 0xf7, 0x4f, 0xc2, 0xab, 0xf0, 0x7c, 0xc5)),
    :PublicRingtones        => StupidWindowsGUID(0xe555ab60, 0x153b, 0x4d17, (0x9f, 0x04, 0xa5, 0xfe, 0x99, 0xfc, 0x15, 0xec)),
    :PublicUserTiles        => StupidWindowsGUID(0x0482af6c, 0x08f1, 0x4c34, (0x8c, 0x90, 0xe1, 0x7e, 0xc9, 0x8b, 0x1e, 0x17)),
    :PublicVideos           => StupidWindowsGUID(0x2400183a, 0x6185, 0x49fb, (0xa2, 0xd8, 0x4a, 0x39, 0x2a, 0x60, 0x2b, 0xa3)),
    :QuickLaunch            => StupidWindowsGUID(0x52a4f021, 0x7b75, 0x48a9, (0x9f, 0x6b, 0x4b, 0x87, 0xa2, 0x10, 0xbc, 0x8f)),
    :Recent                 => StupidWindowsGUID(0xae50c081, 0xebd2, 0x438a, (0x86, 0x55, 0x8a, 0x09, 0x2e, 0x34, 0x98, 0x7a)),
    :RecordedCalls          => StupidWindowsGUID(0x2f8b40c2, 0x83ed, 0x48ee, (0xb3, 0x83, 0xa1, 0xf1, 0x57, 0xec, 0x6f, 0x9a)),
    :RecordedTVLibrary      => StupidWindowsGUID(0x1a6fdba2, 0xf42d, 0x4358, (0xa7, 0x98, 0xb7, 0x4d, 0x74, 0x59, 0x26, 0xc5)),
    :RecycleBinFolder       => StupidWindowsGUID(0xb7534046, 0x3ecb, 0x4c18, (0xbe, 0x4e, 0x64, 0xcd, 0x4c, 0xb7, 0xd6, 0xac)),
    :ResourceDir            => StupidWindowsGUID(0x8ad10c31, 0x2adb, 0x4296, (0xa8, 0xf7, 0xe4, 0x70, 0x12, 0x32, 0xc9, 0x72)),
    :RetailDemo             => StupidWindowsGUID(0x12d4c69e, 0x24ad, 0x4923, (0xbe, 0x19, 0x31, 0x32, 0x1c, 0x43, 0xa7, 0x67)),
    :Ringtones              => StupidWindowsGUID(0xc870044b, 0xf49e, 0x4126, (0xa9, 0xc3, 0xb5, 0x2a, 0x1f, 0xf4, 0x11, 0xe8)),
    :RoamedTileImages       => StupidWindowsGUID(0xaaa8d5a5, 0xf1d6, 0x4259, (0xba, 0xa8, 0x78, 0xe7, 0xef, 0x60, 0x83, 0x5e)),
    :RoamingAppData         => StupidWindowsGUID(0x3eb685db, 0x65f9, 0x4cf6, (0xa0, 0x3a, 0xe3, 0xef, 0x65, 0x72, 0x9f, 0x3d)),
    :RoamingTiles           => StupidWindowsGUID(0x00bcfc5a, 0xed94, 0x4e48, (0x96, 0xa1, 0x3f, 0x62, 0x17, 0xf2, 0x19, 0x90)),
    :SampleMusic            => StupidWindowsGUID(0xb250c668, 0xf57d, 0x4ee1, (0xa6, 0x3c, 0x29, 0x0e, 0xe7, 0xd1, 0xaa, 0x1f)),
    :SamplePictures         => StupidWindowsGUID(0xc4900540, 0x2379, 0x4c75, (0x84, 0x4b, 0x64, 0xe6, 0xfa, 0xf8, 0x71, 0x6b)),
    :SamplePlaylists        => StupidWindowsGUID(0x15ca69b3, 0x30ee, 0x49c1, (0xac, 0xe1, 0x6b, 0x5e, 0xc3, 0x72, 0xaf, 0xb5)),
    :SampleVideos           => StupidWindowsGUID(0x859ead94, 0x2e85, 0x48ad, (0xa7, 0x1a, 0x09, 0x69, 0xcb, 0x56, 0xa6, 0xcd)),
    :SavedGames             => StupidWindowsGUID(0x4c5c32ff, 0xbb9d, 0x43b0, (0xb5, 0xb4, 0x2d, 0x72, 0xe5, 0x4e, 0xaa, 0xa4)),
    :SavedPictures          => StupidWindowsGUID(0x3b193882, 0xd3ad, 0x4eab, (0x96, 0x5a, 0x69, 0x82, 0x9d, 0x1f, 0xb5, 0x9f)),
    :SavedPicturesLibrary   => StupidWindowsGUID(0xe25b5812, 0xbe88, 0x4bd9, (0x94, 0xb0, 0x29, 0x23, 0x34, 0x77, 0xb6, 0xc3)),
    :SavedSearches          => StupidWindowsGUID(0x7d1d3a04, 0xdebb, 0x4115, (0x95, 0xcf, 0x2f, 0x29, 0xda, 0x29, 0x20, 0xda)),
    :Screenshots            => StupidWindowsGUID(0xb7bede81, 0xdf94, 0x4682, (0xa7, 0xd8, 0x57, 0xa5, 0x26, 0x20, 0xb8, 0x6f)),
    :SearchCsc              => StupidWindowsGUID(0xee32e446, 0x31ca, 0x4aba, (0x81, 0x4f, 0xa5, 0xeb, 0xd2, 0xfd, 0x6d, 0x5e)),
    :SearchMapi             => StupidWindowsGUID(0x98ec0e18, 0x2098, 0x4d44, (0x86, 0x44, 0x66, 0x97, 0x93, 0x15, 0xa2, 0x81)),
    :SearchHistory          => StupidWindowsGUID(0x0d4c3db6, 0x03a3, 0x462f, (0xa0, 0xe6, 0x08, 0x92, 0x4c, 0x41, 0xb5, 0xd4)),
    :SearchHome             => StupidWindowsGUID(0x190337d1, 0xb8ca, 0x4121, (0xa6, 0x39, 0x6d, 0x47, 0x2d, 0x16, 0x97, 0x2a)),
    :SearchTemplates        => StupidWindowsGUID(0x7e636bfe, 0xdfa9, 0x4d5e, (0xb4, 0x56, 0xd7, 0xb3, 0x98, 0x51, 0xd8, 0xa9)),
    :SendTo                 => StupidWindowsGUID(0x8983036c, 0x27c0, 0x404b, (0x8f, 0x08, 0x10, 0x2d, 0x10, 0xdc, 0xfd, 0x74)),
    :SidebarDefaultParts    => StupidWindowsGUID(0x7b396e54, 0x9ec5, 0x4300, (0xbe, 0x0a, 0x24, 0x82, 0xeb, 0xae, 0x1a, 0x26)),
    :SidebarParts           => StupidWindowsGUID(0xa75d362e, 0x50fc, 0x4fb7, (0xac, 0x2c, 0xa8, 0xbe, 0xaa, 0x31, 0x44, 0x93)),
    :SkyDrive               => StupidWindowsGUID(0xa52bba46, 0xe9e1, 0x435f, (0xb3, 0xd9, 0x28, 0xda, 0xa6, 0x48, 0xc0, 0xf6)),
    :SkyDriveCameraRoll     => StupidWindowsGUID(0x767e6811, 0x49cb, 0x4273, (0x87, 0xc2, 0x20, 0xf3, 0x55, 0xe1, 0x08, 0x5b)),
    :SkyDriveDocuments      => StupidWindowsGUID(0x24d89e24, 0x2f19, 0x4534, (0x9d, 0xde, 0x6a, 0x66, 0x71, 0xfb, 0xb8, 0xfe)),
    :SkyDriveMusic          => StupidWindowsGUID(0xc3f2459e, 0x80d6, 0x45dc, (0xbf, 0xef, 0x1f, 0x76, 0x9f, 0x2b, 0xe7, 0x30)),
    :SkyDrivePictures       => StupidWindowsGUID(0x339719b5, 0x8c47, 0x4894, (0x94, 0xc2, 0xd8, 0xf7, 0x7a, 0xdd, 0x44, 0xa6)),
    :StartMenu              => StupidWindowsGUID(0x625b53c3, 0xab48, 0x4ec1, (0xba, 0x1f, 0xa1, 0xef, 0x41, 0x46, 0xfc, 0x19)),
    :StartMenuAllPrograms   => StupidWindowsGUID(0xf26305ef, 0x6948, 0x40b9, (0xb2, 0x55, 0x81, 0x45, 0x3d, 0x09, 0xc7, 0x85)),
    :Startup                => StupidWindowsGUID(0xb97d20bb, 0xf46a, 0x4c97, (0xba, 0x10, 0x5e, 0x36, 0x08, 0x43, 0x08, 0x54)),
    :SyncManagerFolder      => StupidWindowsGUID(0x43668bf8, 0xc14e, 0x49b2, (0x97, 0xc9, 0x74, 0x77, 0x84, 0xd7, 0x84, 0xb7)),
    :SyncResultsFolder      => StupidWindowsGUID(0x289a9a43, 0xbe44, 0x4057, (0xa4, 0x1b, 0x58, 0x7a, 0x76, 0xd7, 0xe7, 0xf9)),
    :SyncSetupFolder        => StupidWindowsGUID(0x0f214138, 0xb1d3, 0x4a90, (0xbb, 0xa9, 0x27, 0xcb, 0xc0, 0xc5, 0x38, 0x9a)),
    :System                 => StupidWindowsGUID(0x1ac14e77, 0x02e7, 0x4e5d, (0xb7, 0x44, 0x2e, 0xb1, 0xae, 0x51, 0x98, 0xb7)),
    :SystemX86              => StupidWindowsGUID(0xd65231b0, 0xb2f1, 0x4857, (0xa4, 0xce, 0xa8, 0xe7, 0xc6, 0xea, 0x7d, 0x27)),
    :Templates              => StupidWindowsGUID(0xa63293e8, 0x664e, 0x48db, (0xa0, 0x79, 0xdf, 0x75, 0x9e, 0x05, 0x09, 0xf7)),
    :UserPinned             => StupidWindowsGUID(0x9e3995ab, 0x1f9c, 0x4f13, (0xb8, 0x27, 0x48, 0xb2, 0x4b, 0x6c, 0x71, 0x74)),
    :UserProfiles           => StupidWindowsGUID(0x0762d272, 0xc50a, 0x4bb0, (0xa3, 0x82, 0x69, 0x7d, 0xcd, 0x72, 0x9b, 0x80)),
    :UserProgramFiles       => StupidWindowsGUID(0x5cd7aee2, 0x2219, 0x4a67, (0xb8, 0x5d, 0x6c, 0x9c, 0xe1, 0x56, 0x60, 0xcb)),
    :UserProgramFilesCommon => StupidWindowsGUID(0xbcbd3057, 0xca5c, 0x4622, (0xb4, 0x2d, 0xbc, 0x56, 0xdb, 0x0a, 0xe5, 0x16)),
    :UsersFiles             => StupidWindowsGUID(0xf3ce0f7c, 0x4901, 0x4acc, (0x86, 0x48, 0xd5, 0xd4, 0x4b, 0x04, 0xef, 0x8f)),
    :UsersLibraries         => StupidWindowsGUID(0xa302545d, 0xdeff, 0x464b, (0xab, 0xe8, 0x61, 0xc8, 0x64, 0x8d, 0x93, 0x9b)),
    :Videos                 => StupidWindowsGUID(0x18989b1d, 0x99b5, 0x455b, (0x84, 0x1c, 0xab, 0x7c, 0x74, 0xe4, 0xdd, 0xfc)),
    :VideosLibrary          => StupidWindowsGUID(0x491e922f, 0x5643, 0x4af4, (0xa7, 0xeb, 0x4e, 0x7a, 0x13, 0x8d, 0x81, 0x74)),
    :Windows                => StupidWindowsGUID(0xf38bf404, 0x1d43, 0x42f2, (0x93, 0x05, 0x67, 0xde, 0x0b, 0x28, 0xfc, 0x23)))

function unsafe_utf16string(ptr::Ptr{UInt16})
    ptr == C_NULL && return
    len = 0
    while unsafe_load(ptr, len + 1) != 0
        len += 1
    end
    len == 0 && return ""
    buf = Vector{UInt16}(undef, len)
    unsafe_copyto!(pointer(buf), ptr, len)
    transcode(String, buf)
end

function knownfolder(id::Symbol)
    guid = KNOWN_FOLDER_IDS[id]
    ptr = Ref(Ptr{UInt16}())
    err = ccall((:SHGetKnownFolderPath, "shell32"), stdcall, UInt32,
                (Ref{StupidWindowsGUID}, Cuint, Ptr{Cvoid}, Ptr{Ptr{UInt16}}),
                Ref(guid), 0, C_NULL, ptr)
    if iszero(err)
        folder = unsafe_utf16string(ptr[])
        ccall((:CoTaskMemFree, "ole32.dll"), stdcall, Cvoid, (Ptr{Cvoid},), ptr[])
        folder
    end
end

function knownfolder(id::Symbol, envvars::Vector{String}, default::String)
    firstenv(envvars) =
        for envvar in envvars
            if haskey(ENV, envvar)
                return ENV[envvar]
            end
        end
    something(knownfolder(id), firstenv(envvars), default)
end

knownfolder(id::Symbol, default::String) = something(knownfolder(id), default)

const RELEVANT_FOLDERS =
    (:SystemDrive, :SystemRoot,
     :ProgramData, :Programs, :CommonPrograms,
     :Profile, :RoamingAppData, :LocalAppData,
     :Desktop, :Downloads, :Documents, :Music, :Pictures,
     :Videos, :Templates, :Public, :Fonts)

eval(Expr(:struct, true, :RelevantFolders,
          Expr(:block,
               map(f -> Expr(:(::), f, :String),
                   RELEVANT_FOLDERS)...)))

eval(Expr(:(=), Expr(:call, :RelevantFolders),
          Expr(:call, :RelevantFolders, fill("", length(RELEVANT_FOLDERS))...)))

function relevantfolders()
    rf = RelevantFolders()
    home = homedir()
    rf.SystemDrive = knownfolder(
        :Windows, ["SystemDrive", "SystemRoot", "windir"], home) |>
            splitdrive |> first
    rf.SystemRoot = knownfolder(
        :Windows, ["SystemRoot", "windir"], joinpath(rf.SystemDrive, "Windows"))
    rf.ProgramData = knownfolder(
        :ProgramData, ["ProgramData", "ALLUSERSPROFILE"], joinpath(rf.SystemDrive, "ProgramData"))
    rf.Profile = knownfolder(
        :Profile, joinpath(rf.SystemDrive, "Users"))
    rf.RoamingAppData = knownfolder(
        :RoamingAppData, ["APPDATA"], joinpath(home, "AppData", "Roaming"))
    rf.LocalAppData = knownfolder(
        :LocalAppData, ["LOCALAPPDATA"], joinpath(home, "AppData", "Local"))
    rf.Desktop = knownfolder(:Desktop, joinpath(home, "Desktop"))
    rf.Downloads = knownfolder(:Downloads, joinpath(home, "Downloads"))
    rf.Documents = knownfolder(:Documents, joinpath(home, "Documents"))
    rf.Music = knownfolder(:Music, joinpath(home, "Music"))
    rf.Pictures = knownfolder(:Pictures, joinpath(home, "Pictures"))
    rf.Videos = knownfolder(:Videos, joinpath(home, "Videos"))
    rf.Templates = knownfolder(
        :Templates, joinpath(rf.RoamingAppData, "Microsoft", "Windows", "Templates"))
    rf.Public = knownfolder(:Public, ["Public"], joinpath(rf.Profile, "Public"))
    rf.Fonts = knownfolder(:Fonts, joinpath(rf.SystemRoot, "Fonts"))
    rf.Programs = knownfolder(
        :Programs, joinpath(rf.RoamingAppData, "Microsoft", "Windows", "Start Menu", "Programs"))
    rf.CommonPrograms = knownfolder(
        :CommonPrograms, joinpath(rf.ProgramData, "Microsoft", "Windows", "Start Menu", "Programs"))
    rf
end

function reload()
    rf = relevantfolders()
    # Base directories
    @setxdg DATA_HOME rf.RoamingAppData
    @setxdgs DATA_DIRS [rf.ProgramData]
    @setxdg CONFIG_HOME rf.RoamingAppData
    @setxdgs CONFIG_DIRS [rf.ProgramData]
    @setxdg STATE_HOME rf.LocalAppData
    @setxdg CACHE_HOME joinpath(rf.LocalAppData, "cache")
    @setxdg RUNTIME_DIR rf.LocalAppData
    @setxdg BIN_HOME let
        path = split(get(ENV, "PATH", ""), ';')
        # REVIEW The list of checked directories here.
        # - Should `LocalAppData` be added?
        # - Should `<juliainstall>\bin` be (re-)used?
        binmaybe = [joinpath(homedir(), "bin"),
                    joinpath(rf.RoamingAppData, "bin"),
                    joinpath(rf.LocalAppData, "bin")]
        Iterators.flatten((Iterators.filter(p -> p in path, binmaybe),
                           (first(binmaybe),))) |> first
    end
    # User directories
    @setxdg DESKTOP_DIR rf.Desktop
    @setxdg DOWNLOAD_DIR rf.Downloads
    @setxdg DOCUMENTS_DIR rf.Documents
    @setxdg PROJECTS_DIR joinpath(rf.Profile, "Projects")
    @setxdg MUSIC_DIR rf.Music
    @setxdg PICTURES_DIR rf.Pictures
    @setxdg VIDEOS_DIR rf.Videos
    @setxdg TEMPLATES_DIR rf.Templates
    @setxdg PUBLICSHARE_DIR rf.Public
    # Other directories
    global FONTS_DIRS = [rf.Fonts, joinpath(rf.LocalAppData, "Microsoft", "Windows", "Fonts")]
    global APPLICATIONS_DIRS = [rf.Programs, rf.CommonPrograms]
    nothing
end

applicationpath(app::App, kind::Symbol, ::String) =
    joinpath(applicationpath(app), if kind === :data
                 "data\\"
             elseif kind === :config
                 "config\\"
             elseif kind === :cache
                 "cache\\"
             elseif kind === :state
                 "state\\"
             else
                 ""
             end)

function applicationpath(app::App, kind::Symbol, parents::Vector{String})
    if isempty(parents)
        applicationpath(app)
    else
        applicationpath(app, kind, first(parents))
    end
end

applicationpath(app::App) = joinpath(app.org, app.name, "")

# Base directory

DATA_HOME::String = ""
DATA_DIRS::Vector{String} = []
CONFIG_HOME::String = ""
CONFIG_DIRS::Vector{String} = []
BIN_HOME::String = "" # Not yet standardized.
STATE_HOME::String = ""
CACHE_HOME::String = ""
RUNTIME_DIR::String = ""

# User directories

DESKTOP_DIR::String = ""
DOWNLOAD_DIR::String = ""
DOCUMENTS_DIR::String = ""
PROJECTS_DIR::String = ""
MUSIC_DIR::String = ""
PICTURES_DIR::String = ""
VIDEOS_DIR::String = ""
TEMPLATES_DIR::String = ""
PUBLICSHARE_DIR::String = ""

# Other directories

APPLICATIONS_DIRS::Vector{String} = []
FONTS_DIRS::Vector{String} = []

# Helper functions and macros

module Internals

using ..BaseDirs
using Base.Docs

export @defaccessor, @setxdg, @setxdgs

chopxdgsuffix(path::AbstractString) = String(rstrip(path, @static(if Sys.iswindows(); ('/', '\\') else '/' end)))

@static if Sys.isunix()
    macro setxdg(envvar::Symbol, prioritydefault, default = nothing)
        if isnothing(default)
            prioritydefault, default = "", prioritydefault
        end
        quote global $(esc(envvar)) = if !isempty($(esc(prioritydefault)))
            $(esc(prioritydefault))
        elseif haskey(ENV, $("XDG_$envvar")) && !isempty(ENV[$("XDG_$envvar")])
            chopxdgsuffix(ENV[$("XDG_$envvar")])
        else expanduser($(esc(default))) end
        end
    end
else
    macro setxdg(envvar::Symbol, default)
        quote global $(esc(envvar)) = if haskey(ENV, $("XDG_$envvar")) && !isempty(ENV[$("XDG_$envvar")])
            chopxdgsuffix(ENV[$("XDG_$envvar")])
        else $(esc(default)) end
        end
    end
end

macro setxdgs(envvar::Symbol, defaults)
    quote global $(esc(envvar)) = if haskey(ENV, $("XDG_$envvar")) && !isempty(ENV[$("XDG_$envvar")])
        map(chopxdgsuffix, split(ENV[$("XDG_$envvar")], @static if Sys.iswindows() ';' else ':' end))
    else $(esc(defaults)) end
    end
end

const NEW_BASEDIR_MODE = 0o700

ensurebasedir(path::String) =
    isdir(path) || mkpath(path, mode=NEW_BASEDIR_MODE)

const DIRECTORY_SUFFIX_FLAG = '/'

"""
    ensurepath(path::String)

Ensure that `path` exists. Should `path` end with `$DIRECTORY_SUFFIX_FLAG` it is
interpreted as a directory. The directory-suffix `$DIRECTORY_SUFFIX_FLAG` is
used on all filesystems for consistency of the API, regardless of the native
path seperator of the host filesystem.
"""
function ensurepath(path::String)
    if !ispath(path)
        if endswith(path, DIRECTORY_SUFFIX_FLAG) || (Sys.iswindows() && endswith(path, "\\"))
            mkpath(path[begin:prevind(path, end)])
        else
            mkpath(dirname(path))
            touch(path)
        end
    end
end

"""
    ensureexecutable(path::String)

Make `path` executable by everybody who can read it. Returns `path`.
"""
function ensureexecutable(path::String)
    if isfile(path)
        basemode = filemode(path)
        uread = basemode & 0o400 > 0
        gread = basemode & 0o040 > 0
        oread = basemode & 0o004 > 0
        xmask = 0o100 * uread + 0o010 * gread + 0o001 * oread
        chmod(path, basemode | xmask)
    end
    path
end

"""
    PROMISED_NO_CONST_ASSIGNMENT

Whether it is promised that no constant assignment will be made to a `BaseDirs`.
"""
PROMISED_NO_CONST_ASSIGNMENT::Bool = false

function warn_if_precompiling()
    if ccall(:jl_generating_output, Cint, ()) != 0 && !PROMISED_NO_CONST_ASSIGNMENT
        @noinline (function ()
                       st = stacktrace(backtrace())
                       any(sf -> sf.func ∈ (:__init__, :_atexit), st) && return
                       naughtyline = findfirst(sf -> sf.file != Symbol(@__FILE__), st)
                       naughtysf = st[something(naughtyline, 1)]
                       @warn """A base directory is being computed during precompilation.
                                This is dangerous, as results depend on the live system configuration.

                                It is recommended that you invoke BaseDirs as required in
                                function bodies, rather than at the top level. Calls are very
                                cheap, and you can always pass the result of a live call around.

                                If you have verified that this call was not assigned to a global constant,
                                you can silence this warning with `BaseDirs.@promise_no_assign`.
                                """ _module="BaseDirs" _file=String(naughtysf.file) _line=naughtysf.line
                   end)()
    end
end

function warn_misplaced_promise()
    if ccall(:jl_generating_output, Cint, ()) == 0
        @noinline (function ()
                       st = stacktrace(backtrace())
                       naughtyline = findfirst(sf -> sf.file != Symbol(@__FILE__), st)
                       naughtysf = st[something(naughtyline, 1)]
                       @warn """A `BaseDirs.@promise_no_assign` declaration has been evalated at runtime.
                                This macro is explicitly intended for use during precompilation, and is likely misplaced.
                                """ _module="BaseDirs" _file=String(naughtysf.file) _line=naughtysf.line
                   end)()
    end
end

function resolvedirpath(basedir::String, pathcomponents::Union{<:Tuple{Vararg{S}}, <:AbstractVector{S}}; create::Bool=false) where {S<:AbstractString}
    create && ensurebasedir(basedir)
    if isempty(pathcomponents)
        basedir
    else
        fullpath = joinpath(basedir, pathcomponents...)
        create && ensurepath(fullpath)
        fullpath
    end
end

function resolvedirpaths(basedirs::Vector{String}, pathcomponents::Union{<:Tuple{Vararg{S}}, <:AbstractVector{S}}; create::Bool=false, existent::Bool=false) where {S<:AbstractString}
    allpaths = [resolvedirpath(bdir, pathcomponents; create) for bdir in basedirs]
    isreachablepath(path::String) = try ispath(path) catch; false end
    if existent
        filter(isreachablepath, allpaths)
    else
        allpaths
    end
end

macro defaccessor(fnname::Symbol, var::Union{Symbol, Expr})
    dirvar = if var isa Symbol
        GlobalRef(BaseDirs, var)
    else esc(var) end
    vecfns = (:vec, :vcat, :filter, :map, :push!, :pushfirst!) # a few that come to mind
    resolver = if (var isa Symbol && getfield(BaseDirs, var) isa Vector{String}) ||
          (var isa Expr && (var.head == :vect ||
                            (var.head == :call && var.args[1] in vecfns)))
        :resolvedirpaths
    else
        :resolvedirpath
    end
    quote
        function $(esc(fnname))(pathcomponents...; kwargs...)
            $warn_if_precompiling()
            $resolver($dirvar, pathcomponents; kwargs...)
        end
        $(esc(fnname))(app::BaseDirs.App, pathcomponents...; kwargs...) =
            $(esc(fnname))(BaseDirs.applicationpath(app, $(QuoteNode(fnname)), $dirvar), pathcomponents...; kwargs...)
        $(esc(fnname))(mod::Module, pathcomponents...; kwargs...) =
            $(esc(fnname))(BaseDirs.App(mod), pathcomponents...; kwargs...)
    end
end

function accessordoc(finfo::Union{Symbol, Tuple{String, Symbol}},
                    var::Union{Nothing, Symbol, Vector{Symbol}}=nothing;
                    plural::Bool=if isnothing(var) false
                    elseif var isa Vector true
                    else getfield(BaseDirs, var) isa Vector{String} end,
                    name::String=String(if finfo isa Symbol finfo else last(finfo) end))
    fprefix, fname = if finfo isa Symbol; ("", finfo) else finfo end
    rettype = ifelse(plural, "Vector{String}", "String")
    dirprefix, dirterm = ifelse(plural, ("all", "directories"), ("the", "directory"))
    existentkwarg = ifelse(plural, " - `existent::Bool` (default `false`), filter out paths that do not exist.", "")
    vardoc = if var isa Vector && (dvars = filter(v -> haskey(Docs.meta(BaseDirs), Docs.Binding(BaseDirs, v)), var)) |> !isempty
        "\nThe returned path is determined by the value of $(join(map(v -> "[`BaseDirs.$v`](@ref)", dvars), ", ", ", and ")), which see.\n"
    elseif var isa Symbol && haskey(Docs.meta(BaseDirs), Docs.Binding(BaseDirs, var))
        "\nThe returned path is determined by the value of [`BaseDirs.$var`](@ref), which see.\n"
    else "" end
    kwargs = ifelse(plural, "; create, existent", "; create")
    """
    $fprefix$fname($kwargs) -> $rettype # $dirprefix $name $dirterm
    $fprefix$fname([mod::Module or app::App], parts...$kwargs) # an [application-specific] $name path

Locate $dirprefix $name $dirterm, or a path within it.

An application or module can be optionally provided as the first argument, in
which case the returned path is scoped to the application or module.

$vardoc
## Keyword arguments
 - `create::Bool` (default `false`), whether the path should be created if it
   does not exist. Paths ending in `$DIRECTORY_SUFFIX_FLAG` are interpreted as
   directories, and all other paths are considered files. This takes care to
   create the base directories with the appropriate permissions ($(string(NEW_BASEDIR_MODE, base=8))).
$existentkwarg"""
end

end

using BaseDirs
using Documenter
using Org

orgfiles = filter(f -> endswith(f, ".org"),
                  readdir(joinpath(@__DIR__, "src"), join=true))

for orgfile in orgfiles
    mdfile = replace(orgfile, r"\.org$" => ".md")
    read(orgfile, String) |>
        c -> Org.parse(OrgDoc, c) |>
        o -> sprint(markdown, o) |>
        s -> replace(s, r"\.org]" => ".md]") |>
        m -> write(mdfile, m)
end

makedocs(;
    modules=[BaseDirs],
    authors="TEC <git@tecosaur.net> and contributors",
    repo="https://github.com/tecosaur/BaseDirs.jl/blob/{commit}{path}#{line}",
    sitename="BaseDirs.jl",
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        canonical="https://tecosaur.github.io/BaseDirs.jl",
        edit_link="main",
        assets=["assets/favicon.ico"],
    ),
    pages=[
        "Introduction" => "index.md",
        "Usage" => "usage.md",
        "Defaults" => "defaults.md",
        "Prior Art" => "others.md",
    ],
    warnonly = [:missing_docs, :cross_references],
)

deploydocs(;
    repo="github.com/tecosaur/BaseDirs.jl",
    devbranch="main",
)
